#!/usr/local/bin/bash
# put other system startup commands here

/sbin/init -q

### MicroCore Directory
BOOTDEV=$(sudo -i -u tc autoscan 'tce' 'd')
ln -s /mnt/$BOOTDEV/tce /tce

### Mount the Datastore on the drive specified in wanos.conf
# e.g.
/usr/sbin/rebuildfstab
for FSTAB in $(grep ^/dev/sd /etc/fstab | awk '{print $1}')
do
        test `df -h | grep -c ^$FSTAB` -eq 0 && mount $FSTAB
done

DSTORE=`grep ^DSTORE= /tce/etc/wanos/wanos.conf | awk -F= '{print $2}'`
PARTITION=`blkid /dev/$DSTORE | awk '{print $3}'`
if [[ $PARTITION = *"ext"* && $DSTORE = *"sd"* ]]; then
 test ! -d /mnt/$DSTORE && mkdir /mnt/$DSTORE
 test `df -h | grep -c ^/dev/$DSTORE` -eq 0 && mount /dev/$DSTORE /mnt/$DSTORE
 ln -s /mnt/$DSTORE/wanos /wanos
else
### Default Wanos Directory
ln -s /mnt/$BOOTDEV/wanos /wanos
fi

### Copy Startup to Running Configuration Files
cp -R /tce/etc/* /etc/

### Set Hostname
/tce/etc/wanos/sethostname
rm /usr/bin/sethostname
ln -s /tce/etc/wanos/sethostname /usr/bin/sethostname

### Set permissions
sudo -u tc /tce/etc/wanos/setdir

### Install & Links
ln -s /tce/etc/wanos/wanos-cfg /usr/bin/wanos-cfg
ln -s /tce/etc/wanos/wanos-log /usr/bin/wanos-log
ln -s /tce/etc/wanos/wanos-show /usr/bin/wanos-show
ln -s /tce/packages/ethtool/ethtool /usr/local/sbin/ethtool
ln -s /tce/packages/click/exporttool /usr/local/sbin/exporttool
/bin/rpm -i /tce/packages/click/ftool.uo
/usr/bin/install -c -m 644 /tce/packages/click/wanos.uo  /usr/local/lib/
/usr/bin/install -c -m 644 /tce/packages/click/netflow.uo  /usr/local/lib/
/usr/bin/install -c /tce/packages/click/wanos_extra_packages.uo  /usr/local/lib/
/usr/bin/install -c /tce/packages/click/libclick.a  /usr/local/lib/
/usr/bin/install -c /tce/packages/click/libwanos_extra.so  /usr/local/lib/
/usr/bin/install -c /tce/packages/click/click  /usr/local/bin/

## SSH
cp -R /tce/etc/ssh /usr/local/etc/
SSHD=`grep ^SSHD= /tce/etc/wanos/wanos.conf | awk -F= '{print $2}'`
if [[ $SSHD = "enable" ]]; then
/usr/local/etc/init.d/openssh start
fi
ln -s /usr/local/etc/ssl /usr/local/ssl

## SNMPD
SNMPD=`grep ^SNMPD= /tce/etc/wanos/wanos.conf | awk -F= '{print $2}'`
if [[ $SNMPD = "enable" ]]; then
snmpd -f /tce/etc/wanos/snmpd.conf
fi 

## Webcache
HTTP_CACHE_REDIRECT=`grep ^HTTP_CACHE_REDIRECT= /tce/etc/wanos/wanos.conf | awk -F= '{print $2}'`
if [[ $HTTP_CACHE_REDIRECT = "true" ]]; then
/tce/etc/wanos/webcache
fi 

### Lighttpd
/usr/local/sbin/lighttpd -f /tce/etc/lighttpd.conf >> /wanos/wanos.log

### Clean Memory
sync
echo 3 > /proc/sys/vm/drop_caches

### Start Wanos Daemon
sudo -u tc /tce/etc/init.d/wanosd start &

### Crontab
/usr/sbin/crond -d 10 > /dev/null
crontab -u tc /tce/etc/crontab > /dev/null

### Info
sleep 3
echo "############################"
echo "   Press Enter to Login     "
echo "############################"

### Initiate Statistic Files
sleep 30
sudo -u tc /tce/etc/wanos/stats.sh >> /wanos/wanos.log 2>> /wanos/wanos.log

### Bash update
rm -rf /usr/local/bin/bash
ln -s /tce/packages/bash/bash /usr/local/bin/bash
