#!/usr/local/bin/bash
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.org/license or email info@wanos.org for more information.
#
 

sleep 2
THREADS=`grep -c "^processor" /proc/cpuinfo`
rrdtool=/usr/local/bin/rrdtool
db=/tce/www/stats/cpu.rrd
img=/tce/www/stats

if [ ! -e $db ]
then
	for (( i=0; i<$THREADS; i++ ))
	do
		DS_STR="$DS_STR DS:cpu$i:COUNTER:600:0:101 "
	done
	$rrdtool create $db \
	$DS_STR \
	RRA:AVERAGE:0.5:1:576 \
	RRA:AVERAGE:0.5:6:672 \
	RRA:AVERAGE:0.5:24:732 \
	RRA:AVERAGE:0.5:144:1460

fi


for (( i=0; i<$THREADS; i++ ))
do
    cpu_str="cpu$i"
    cpu=`grep "^$cpu_str" /proc/stat | awk '{print $2}'`
    str1="$str1:cpu$i"
    str2="$str2:$cpu"
done
    str1=`echo $str1 | sed 's/://'`
    $rrdtool update $db -t $str1 N$str2

    for period in Hour Day Week Month Year
    do
	LONG_RRD=""
	for (( i=0; i<$THREADS; i++ ))
	do
		cpu_str="cpu$i"
		LONG_RRD="$LONG_RRD  DEF:$cpu_str=$db:$cpu_str:AVERAGE  VDEF:min$cpu_str=$cpu_str,MINIMUM  VDEF:max$cpu_str=$cpu_str,MAXIMUM  VDEF:avg$cpu_str=$cpu_str,AVERAGE  VDEF:lst$cpu_str=$cpu_str,LAST  COMMENT:\t AREA:$cpu_str#556E0AAA:$cpu_str\t  LINE1:$cpu_str#556E0A GPRINT:min$cpu_str:%2.1lf\t  GPRINT:max$cpu_str:%2.1lf\t  GPRINT:avg$cpu_str:%2.1lf\t  GPRINT:lst$cpu_str:%2.1lf\l" 
	done

	$rrdtool graph $img/cpu-$period.png -s -1$period \
	-t "CPU the Last $period" -z \
	-c "BACK#FAFAFA" -c "SHADEA#FAFAFA" -c "SHADEB#FAFAFA" \
	-c "MGRID#AAAAAAAA" -c "GRID#CCCCCCAA" -c "ARROW#333333" \
	-c "FONT#333333" -c "AXIS#333333" -c "FRAME#333333" \
        -h 134 -w 543 -l 0 -a PNG -v "CPU" -u 100 \
	"COMMENT: \l" \
	"COMMENT:\t\t\t" \
	"COMMENT:Minimum\t" \
	"COMMENT:Maximum\t" \
	"COMMENT:Average\t" \
	"COMMENT:Current\l" \
	$LONG_RRD  > /dev/null
   done

