#!/usr/local/bin/bash
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.org/license or email info@wanos.org for more information.
#
 

rrdtool=/usr/local/bin/rrdtool
img=/tce/www/stats

for if in `ls /sys/class/net/ | grep 'eth\|wan\|lan'`; do  

db=/tce/www/stats/$if.rrd
if [ ! -e $db ]
then 
	$rrdtool create $db \
	DS:in:DERIVE:600:0:125000000 \
	DS:out:DERIVE:600:0:125000000 \
	RRA:AVERAGE:0.5:1:576 \
	RRA:AVERAGE:0.5:6:672 \
	RRA:AVERAGE:0.5:24:732 \
	RRA:AVERAGE:0.5:144:1460
fi


rx=`cat /sys/class/net/$if/statistics/rx_bytes`
tx=`cat /sys/class/net/$if/statistics/tx_bytes`

$rrdtool update $db -t in:out N:$rx:$tx


	$rrdtool graph $img/$if-custom.png -s -10Hour0Minute -e -4Hour0Minute \
	-t "$if Network traffic the Last Custom" -z \
	-c "BACK#FAFAFA" -c "SHADEA#FAFAFA" -c "SHADEB#FAFAFA" \
	-c "MGRID#AAAAAAAA" -c "GRID#CCCCCCAA" -c "ARROW#333333" \
	-c "FONT#333333" -c "AXIS#333333" -c "FRAME#333333" \
        -h 134 -w 543 -l 0 -a PNG -v "b/s" \
	DEF:in=$db:in:AVERAGE \
	DEF:out=$db:out:AVERAGE \
	CDEF:inbits=in,8,* \
	CDEF:outbits=out,-8,* \
	CDEF:outbits2=outbits,-1,/ \
	VDEF:minin=inbits,MINIMUM \
	VDEF:minout=outbits2,MINIMUM \
	VDEF:maxin=inbits,MAXIMUM \
	VDEF:maxout=outbits2,MAXIMUM \
	VDEF:avgin=inbits,AVERAGE \
	VDEF:avgout=outbits2,AVERAGE \
	VDEF:lstin=inbits,LAST \
	VDEF:lstout=outbits2,LAST \
	VDEF:totin=in,TOTAL \
	VDEF:totout=out,TOTAL \
	"COMMENT: \l" \
	"COMMENT:               " \
	"COMMENT:Minimum      " \
	"COMMENT:Maximum      " \
	"COMMENT:Average      " \
	"COMMENT:Current      " \
	"COMMENT:Total        \l" \
	"COMMENT:   " \
	"AREA:outbits#707070CC:Out  " \
	"LINE1:outbits#707070" \
	"GPRINT:minout:%5.1lf %sb/s   " \
	"GPRINT:maxout:%5.1lf %sb/s   " \
	"GPRINT:avgout:%5.1lf %sb/s   " \
	"GPRINT:lstout:%5.1lf %sb/s   " \
	"GPRINT:totout:%5.1lf %sB   \l" \
	"COMMENT:   " \
	"AREA:inbits#556E0ACC:In   " \
	"LINE1:inbits#556E0A" \
	"GPRINT:minin:%5.1lf %sb/s   " \
	"GPRINT:maxin:%5.1lf %sb/s   " \
	"GPRINT:avgin:%5.1lf %sb/s   " \
	"GPRINT:lstin:%5.1lf %sb/s   " \
	"GPRINT:totin:%5.1lf %sB   \l" > /dev/null
done
