#!/usr/bin/perl
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.org/license or email info@wanos.org for more information.
#


my ($mac, $cpu) = @ARGV;

open(CONFIG, "<" , "/tce/etc/wanos/wanos.conf") || die("Couldn't open the file. Error: $!\n");
    while (<CONFIG>)
    {
    chomp;
    next if /^\s*\#/;
    next unless /=/;
    my ($key, $variable) = split(/\s*=\s*/,$_,2);
    $variable =~ s/(\$(\w+))/$config{$2}/g;
        $config{$key} = $variable;
    }
close CONFIG;

my %virtual_nets = ();
my $virt_lan0;
my $virt_mask;
my $exit_last;
my $deployment_mode = $config{DEPLOYMENT_MODE};
my $ipno = qr/2(?:5[0-5]|[0-4]\d)|1\d\d|[1-9]?\d/x;





if ($deployment_mode eq "router" && $config{VIRT_LAN0} ne '')
{
	($virt_lan0, $virt_mask) = split('/',$config{VIRT_LAN0});
	if (($virt_lan0 =~ /^($ipno\.){3}$ipno$/ ) && ($virt_mask >= 7) && ($virt_mask <= 32))
	{
	 $virtual_nets{$virt_lan0} = $virt_mask; 
	 $exit_last = $virt_lan0;
	}
	else
	{
	 print STDERR "Error : VIRT_LAN0 Address / Mask validation failed: $config{VIRT_LAN0} \n";
	 $deployment_mode = "bridge";
	}

	open(ROW, "<" , "/tce/etc/wanos/virtual_lan") || die("Couldn't open the file. Error: $!\n");
	while (<ROW>)
	{
		chomp;
		($virt_lan0, $virt_mask) = split('/',$_);
		if (($virt_lan0 =~ /^($ipno\.){3}$ipno$/ ) && ($virt_mask >= 7) && ($virt_mask <= 32)) { $virtual_nets{$virt_lan0} = $virt_mask; }
		else { print STDERR "Error : VIRT_LAN0 Address / Mask validation failed: " . $_ . " \n"; }
	}
	close ROW;
}


$matchmac=$mac;
$matchmac=~tr/://d;

my $encapproto = "6C";
my $proto_num = 108;
if ($config{ENCAPPROTO} eq "gre")
    {
    $encapproto = "2F";
    $proto_num = 47;
    }


print <<EOF;

//
// Deployment method
//

EOF

if ($deployment_mode eq "bridge")
{
	if ($config{PMETHOD} eq "NETMAP") { print "wan0 :: FromDevice(netmap:wan0"; }
	else { print "wan0 :: FromDevice(wan0"; }
	print ", SNIFFER false, PROMISC true, METHOD $config{PMETHOD});\n";
	if ($config{PMETHOD} eq "NETMAP") { print "lan0 :: FromDevice(netmap:lan0"; }
	else { print "lan0 :: FromDevice(lan0"; }
	print ", SNIFFER false, PROMISC true, METHOD $config{PMETHOD});\n";
	if ($config{PMETHOD} eq "NETMAP") { print "lan0out :: ToDevice(netmap:lan0, METHOD $config{PMETHOD});\n"; }
	else { print "lan0out :: ToDevice(lan0, METHOD $config{PMETHOD});\n"; }
	if ($config{PMETHOD} eq "NETMAP") { print "tdwan0 :: ToDevice(netmap:wan0, METHOD $config{PMETHOD});\n"; }
	else { print "tdwan0 :: ToDevice(wan0, METHOD $config{PMETHOD});\n"; }
	print "Idle -> [0]lanarp -> Discard;\n";
}
elsif ($deployment_mode eq "router")
{

print "AddressInfo(virtualwan $config{IP} $mac";

my $i = 0;
foreach (keys %virtual_nets)
	{ 
	print " , virtuallan$i $_  00:00:CC:CC:CC:CC "; 
	$i++;
	}
print ");\n";

print <<EOF;
lan0 :: Null;
wan0 :: Null;
fd0 :: FromDevice(wan0, SNIFFER false, PROMISC true, METHOD PCAP);
wan0out :: ThreadSafeQueue(1000) -> ToDevice(wan0, METHOD PCAP);
etherencap :: Classifier(12/0800, -) -> Strip(14) -> virtual_encap_check::CheckIPHeader(VERBOSE $config{VERBOSE}) -> RadixIPLookup($config{NET}/$config{MASK}  0, 
EOF
;

foreach (keys %virtual_nets) { print " $_/$virtual_nets{$_} 0 , "; }

print <<EOF;
0.0.0.0/0 $config{GW} 0) -> [0]lanarp -> wan0out;
etherencap[1] -> wan0out;
lan0out :: Unqueue -> etherencap;
tdwan0 :: Unqueue -> etherencap;
fd0[0] -> virtual_split_filter :: Classifier(0/$matchmac 12/0800, 0/0000CCCCCCCC 12/0800, 12/0806 20/0001, 12/0806 20/0002);
virtual_split_filter[0] -> Strip(14) -> virtual_wan_check::CheckIPHeader(VERBOSE $config{VERBOSE}) -> DecIPTTL -> virtual_wanclass::IPClassifier(dst $config{IP}, -);
virtual_split_filter[1] -> Strip(14) -> virtual_lan_check::CheckIPHeader(VERBOSE $config{VERBOSE}) -> DecIPTTL -> virtual_lanclass::IPClassifier(dst $config{IP}, 
EOF
;

foreach (keys %virtual_nets)
	{
	print " dst $_  ";
	print " or " if !/$exit_last/;
	}
print " , \n";

foreach (keys %virtual_nets)
	{
	print " dst $_/$virtual_nets{$_}  ";
	print " or " if !/$exit_last/;
	}
print " , -);\n";
print "virtual_split_filter[2] -> ARPResponder(virtualwan ";
$i=0;
foreach (keys %virtual_nets) { print ", virtuallan$i "; $i++; }
print ") -> wan0out;\n";
print <<EOF;
virtual_split_filter[3] -> [1]lanarp; 
virtual_wanclass[0] -> Unstrip(14) -> wan0;
virtual_wanclass[1] -> EtherEncap(0x0800, 1:1:1:1:1:1, 2:2:2:2:2:2) -> wan0;
virtual_lanclass[0] -> Unstrip(14) -> lan0;
virtual_lanclass[1] -> ICMPPingResponder -> [0]lanarp;
virtual_lanclass[2] -> [0]lanarp;
virtual_lanclass[3] -> EtherEncap(0x0800, 2:2:2:2:2:2, 1:1:1:1:1:1) -> lan0;
EOF
;

}
elsif ($deployment_mode eq "tunnel")
{
print <<EOF

AddressInfo(wan0 $config{IP} $mac);
lan0 :: Null;
wan0 :: Null;
fd0 :: FromDevice(wan0, SNIFFER false, PROMISC true, METHOD PCAP);
wan0out :: ThreadSafeQueue(1000) -> ToDevice(wan0, METHOD PCAP);

etherencap :: Classifier(12/0800, -) -> Strip(14) -> encap_ipcheck::CheckIPHeader(VERBOSE true) -> RadixIPLookup(0.0.0.0/0 $config{GW} 0) -> [0]lanarp -> wan0out;
etherencap[1] -> wan0out;

lan0out :: Unqueue -> etherencap;
tdwan0 :: Unqueue -> etherencap;

fd0[0] -> l2_filter :: Classifier(0/$matchmac 12/0800, 12/0806 20/0001, 12/0806 20/0002);
l2_filter[0] -> Strip(14) -> wan_check::CheckIPHeader(VERBOSE true) -> tunnel_drop_broadbast::DropBroadcasts -> DecIPTTL -> split_filter::IPClassifier( (dst $config{IP} and src port 4050 and dst port 4050) or (dst $config{IP} and proto 108), dst $config{IP}, -);

l2_filter[1] -> ARPResponder(wan0) -> wan0out;
l2_filter[2] -> [1]lanarp;

split_filter[0] -> EtherEncap(0x0800, 1:1:1:1:1:1, 2:2:2:2:2:2) -> wan0;
split_filter[1] -> Unstrip(14) -> lan0;
split_filter[2] -> EtherEncap(0x0800, 2:2:2:2:2:2, 1:1:1:1:1:1) -> lan0;

EOF
;

}
else { print STDERR "Error : unknown deployment option\n"; }




