#!/usr/local/bin/bash 
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.org/license or email info@wanos.org for more information.
#

cd /tce/etc/wanos/
cp wanos.conf wanos.conf.restore 

case "$1" in
	-net)
	sed -i -r "s/(^IP=*).*/\1$2/" wanos.conf
	sed -i -r "s/(^MASK=*).*/\1$3/" wanos.conf
	sed -i -r "s/(^NET=*).*/\1$4/" wanos.conf
	sed -i -r "s/(^GW=*).*/\1$5/" wanos.conf
	;;
	-sys)
	sed -i -r "s/(^MODE=*).*/\1$2/" wanos.conf
	sed -i -r "s/(^SIM=*).*/\1$3/" wanos.conf
	;;
	-cli)
	sed -i -r "s/(^IP=*).*/\1$2/" wanos.conf
	sed -i -r "s/(^MASK=*).*/\1$3/" wanos.conf
	sed -i -r "s/(^NET=*).*/\1$4/" wanos.conf
	sed -i -r "s/(^GW=*).*/\1$5/" wanos.conf
	sed -i -r "s/(^MODE=*).*/\1$6/" wanos.conf
	sudo /tce/etc/wanos/wanos reconfigure >> /wanos/wanos.log
	;;
	-settings)
	sed -i -r "s/(^MTU=*).*/\1$2/" wanos.conf
	sed -i -r "s/(^HOLD=*).*/\1$3/" wanos.conf
	sed -i -r "s/(^NFEXPIRE=*).*/\1$4/" wanos.conf
	sed -i -r "s/(^NFPEERPORT=*).*/\1$5/" wanos.conf
	sed -i -r "s/(^NFEXPORT=*).*/\1$6/" wanos.conf
	sudo killall nfcapd
	;;
	-host)
	sed -i -r "s/(^HOST=*).*/\1$2/" wanos.conf
	sudo /usr/bin/sethostname $2 >> /wanos/wanos.log
	;;
	-nfpeerip)
	sed -i -r "s/(^NFPEERIP=*).*/\1$2/" wanos.conf
	sudo killall nfcapd
	;;
	-time)
	sudo date --set "$4-$3-$2 $5:$6"
	sudo hwclock --systohc
	sudo rm -rf /wanos/nf/l0/*
	sudo rm -rf /wanos/nf/w0/*
	/tce/etc/wanos/setdir
	sudo killall nfcapd
	;;
	-encapproto)
	sed -i -r "s/(^ENCAPPROTO=*).*/\1$2/" wanos.conf
	;;
	-reconfigure)
	sudo /tce/etc/wanos/wanos reconfigure >> /wanos/wanos.log
	;;
	-showtech)
	/tce/etc/wanos/showtech
	;;
	-benchmark)
	sudo /tce/etc/wanos/benchmark | tee /wanos/bench.log
	;;
	-dstore)
	sed -i -r "s/(^DSTORE=*).*/\1$2/" wanos.conf
        echo "Info : Clearing the datastore" | tee >(./logstamp)
        sudo rm -rf /wanos/ds0/*
	test -e /mnt/$2/wanos/ds0 && sudo rm -rf /mnt/$2/wanos/ds0/*
	test -f /tce/etc/wanos/siteslot && rm -rf /tce/etc/wanos/siteslot
	;;
	-sshd)
	sed -i -r "s/(^SSHD=*).*/\1$2/" wanos.conf
	test $2 = "enable" && sudo /usr/local/etc/init.d/openssh start
	test $2 = "disable" && sudo /usr/local/etc/init.d/openssh stop
	;;
	-sshpass)
	echo "Info : SSH & Web Interface Password Reset" | tee >(./logstamp)
	PS=`grep ^wanos: /tce/etc/.lighttpdpassword | awk -F: '{print $2}'`
	echo tc:$PS | sudo chpasswd
	sudo cp /etc/passwd /tce/etc/passwd
	TIME=`date +%s`
	sed -i -r "s/(^CHPASSWD=*).*/\1$TIME/" wanos.conf
	;;
	-reboot)
	sudo reboot
	;;
	-update)
	cd /tce/www/stats/reports/
	test -f $2 && tar -xvf $2
        test -f	update.sh && chmod +x update.sh
        test -f	update.sh && ./update.sh
        test -f	update.sh && rm -rf update.sh
	;;
	-backupcfg)
	/tce/etc/wanos/backupcfg -backup
	;;
	-restorecfg)
	/tce/etc/wanos/backupcfg -restore $2
	;;
	-comp_lvl)
	sed -i -r "s/(^COMPALGO=*).*/\1$2/" wanos.conf
	;;
	-dd_lvl)
	sed -i -r "s/(^DD_LEVEL=*).*/\1$2/" wanos.conf
	;;
	-rsp_lvl)
	sed -i -r "s/(^RSP_LEVEL=*).*/\1$2/" wanos.conf
	;;
	-deployment)
	sed -i -r "s/(^DEPLOYMENT_MODE=*).*/\1$2/" wanos.conf
	test $2 != "router" && sed -i -r "s/(^VIRT_LAN0=*).*/\1/" wanos.conf 
	;;
	-virtlan)
	sed -i -r "s|(^VIRT_LAN0=*).*|\1$2|" wanos.conf
	;;
	-aqm_num)
	./aqm.sh -num $2
	;;
	-aqm_name)
	./aqm.sh -name
	;;
	-dnsupdate)
	touch /tce/etc/resolv.conf
	DNS1=`grep ^DNS_SERVER_1= wanos.conf | awk -F= '{print $2}'`
	sed -i -r "s/(^DNS_SERVER_1=*).*/\1$2/" wanos.conf
	test ! -z "$DNS1" && sed -i "/$DNS1/d" /etc/resolv.conf
	test ! -z "$DNS1" && sed -i "/$DNS1/d" /tce/etc/resolv.conf
	DNS_EXISTS=`grep $2 /tce/etc/resolv.conf`
	[[ -z "$DNS_EXISTS" ]] && { echo "nameserver $2" >> /tce/etc/resolv.conf; echo "nameserver $2" >> /etc/resolv.conf; }
	;;

esac

