#!/usr/bin/perl
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.org/license or email info@wanos.org for more information.
#
 
use Scalar::Util qw(looks_like_number);

my ($mode) = $ARGV[0];
my ($mss) = $ARGV[1];
my $sim = $ARGV[2];
my $sim_queue = $ARGV[3];
my $wanop_queue = $ARGV[4];
my $http_redirect = $ARGV[5];
my %classes = ();
my %rates = ();
my %rows = ();
my %groupobj = ();
my @missingclasses = (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17);

my $global_red_low = $sim_queue / 20;
my $global_red_high = $sim_queue / 5;
my $wanop_red_low = $wanop_queue / 10;
my $wanop_red_high = $wanop_queue / 2;

open(ROW, "<" , "/tce/etc/wanos/policies") || die("Couldn't open the file. Error: $!\n");
while (<ROW>) 
{                    
	chomp;
	next if /^\s*\#/;           
	next unless /=/;            
	my ($key, $commastring) = split(/\s*=\s*/,$_,2);
	$commastring =~ s/(\$(\w+))/$rows{$2}/g;                             
	$rows{$key} = $commastring;                                      
}                                                                 
close ROW;

open(GROUPOBJ, "<" , "/tce/etc/wanos/groupobjects") || die("Couldn't open the file. Error: $!\n");
while (<GROUPOBJ>)
{
        chomp;
        next if /^\s*\#/;
        next unless /=/;
        my ($key, $commastring) = split(/\s*=\s*/,$_,2);
        $commastring =~ s/(\$(\w+))/$groupobj{$2}/g;
        $groupobj{$key} = $commastring;
}
close GROUPOBJ;


print <<EOF;
//
// Network Policies
//
EOF


print "policymap :: IPClassifier(\n";
print "udp port 53 or icmp,\n";

my $i = 1;
foreach (keys %groupobj)
{
	print "tcp port";
	my @values = split(',',$groupobj{$_});
	my $len = scalar @values;
	my $last = 1;
	foreach (@values)
	{
	    if ($last < $len) { print " $_ or"; }
	    else { print " $_,\n" }
	    $last++;
	}
	$i++;	
}

foreach (sort { $a <=> $b } keys(%rows) )
{
my @values = split(',',$rows{$_});
if (($values[0] ne '') && ($values[1] ne '') && ($values[2] ne ' '))
 { 
   print "src $values[0] and dst $values[1] and $values[2] ,\n";
my %rows = ();
 }
if (($values[0] ne '') && ($values[1] ne '') && ($values[2] eq ' '))
 {
 print "src $values[0] and dst $values[1] ,\n"; 
 }
 $i++;
}
print "-);\n\n";

print "policymap[0] -> Paint(17) -> unstrip0;\n";
print "policymap[1] -> Paint(0) -> unstrip0;\n";
print "policymap[2] -> Paint(17) -> unstrip0;\n";

my $c = 3;
foreach (sort { $a <=> $b } keys(%rows) )
{
 my @values = split(',',$rows{$_});

  if ($values[5] eq 'drop') { print "policymap[$c] -> Discard;\n"; $c++; next; }
 
  if ($values[3] ne '-')
  { 
  my $dscp = convertdscp($values[3]);
  print "policymap[$c] -> SetIPDSCP($dscp) -> ";
  }
  else { print "policymap[$c] -> "; }

 print "Paint($values[4]) -> ";

 if ($values[7] eq 'true') { print "unstrip0;\n";}
 else { print "Paint(1,27) -> unstrip0;\n";}
 
 # While looping build the classes list
 $classes{$values[4]} = $values[5];
 $rates{$values[4]} = ($values[6]*1024)/8;
 $c++;
}
print "policymap[$c] -> Paint(0) -> unstrip0;\n";
print "\n\n";

print "precheck :: Counter -> MSSAdjust -> WanosTCPFragmenter(MTU " . ($mss+80) . ") -> prefrag :: WanosIPFragmenter(" . ($mss+80) . ") -> optable;\n";

if ( $http_redirect eq 'true' )
{
print "http_redirect :: IPClassifier(dst tcp port 80, -) -> encaptun;\n";
print "http_redirect[1] -> precheck;\n";
}
else
{
print "http_redirect :: Null -> precheck;\n";
}

print "admission_control :: RED(" . $wanop_red_low . ", " . $wanop_red_high . ", 0.01, QUEUES wanopout) -> http_redirect;\n";
print "postpolicy :: CheckPaint(1,27);\n";
print "postpolicy[0] -> Strip(14) -> admission_control;\n";
print "postpolicy[1] -> pass_through_tx::Counter -> post_qos;\n";
if ( $sim eq '0') { print "global_wan_red :: Null -> postpolicy;\n"; }
else { print "global_wan_red :: RED(" . $global_red_low . ", " . $global_red_high . ", 0.05, QUEUES pq0 pq1 pq2) -> postpolicy;\n"; }

print "qos[17] -> qos_class17::Counter -> postpolicy;\n";

foreach (sort { $a <=> $b } keys(%classes) ) 
{
print "qos[$_] -> ";

if ($classes{$_} eq 'shape') { print "shaper_queue" . $_ . "::ThreadSafeQueue(" . (sprintf '%0.0f', (($rates{$_}/750)+0.5)) . ") -> shaperunqueue" . $_ . "::BandwidthRatedUnqueue($rates{$_}B/s) -> qos_class" . $_ . "::Counter -> global_wan_red;\n"; }
if ($classes{$_} eq 'high') { print "qos_class" . $_ . "::Counter -> postpolicy;\n"; }
if ($classes{$_} eq 'low') { print "qos_class" . $_ . "::Counter -> global_wan_red;\n"; }
if ($classes{$_} eq '-') { print "qos_class" . $_ . "::Counter -> global_wan_red;\n"; }
#splice(@missingclasses, $_-1, 1);
$missingclasses[$_-1] = 0;
}
print "qos[";
foreach (@missingclasses) { if ($_ != 0) {print "$_,";} }
print "] -> qos_class_all::Counter -> global_wan_red;\n"; 

sub convertdscp {
$dscp = $_[0];
if ($dscp eq 'CS0') {	$dscp=0; }	
if ($dscp eq 'CS1') {   $dscp=8; }
if ($dscp eq 'AF11') {   $dscp=10;}
if ($dscp eq 'AF12') {   $dscp=12;}
if ($dscp eq 'AF13') {   $dscp=14;}	
if ($dscp eq 'CS2') {   $dscp=16;}
if ($dscp eq 'AF21') {   $dscp=18;}
if ($dscp eq 'AF22') {   $dscp=20;}
if ($dscp eq 'AF23') {   $dscp=22;}
if ($dscp eq 'CS3') {   $dscp=24;}
if ($dscp eq 'AF31') {   $dscp=26;}
if ($dscp eq 'AF32') {   $dscp=28;}
if ($dscp eq 'AF33') {   $dscp=30;}
if ($dscp eq 'CS4') {   $dscp=32;}
if ($dscp eq 'AF41') {   $dscp=34;}
if ($dscp eq 'AF42') {   $dscp=36;}
if ($dscp eq 'AF43') {   $dscp=38;}
if ($dscp eq 'CS5') {   $dscp=40;}
if ($dscp eq 'EF') {   $dscp=46;}
if ($dscp eq 'CS6') {   $dscp=48;}
if ($dscp eq 'CS7') {   $dscp=56;}
if (!looks_like_number($dscp)) { $dscp=0;}

return $dscp;
}
