#!/usr/local/bin/bash 
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.org/license or email info@wanos.org for more information.
#
 

cd /tce/etc/wanos/
cp wanos.conf wanos.conf.restore

case "$1" in
	yes)
	rm -rf /tce/www/stats/*
	cp -a /tce/www/stats-def/* /tce/www/stats/
	sudo rm -rf /wanos/nf/l0/*
	sudo rm -rf /wanos/nf/w0/*
	sudo echo > /wanos/wanos.log
	echo "Info : Cleared Statistics and Logs" | tee >(./logstamp)
	/tce/etc/wanos/setdir
	/tce/etc/wanos/stats.sh
	;;
esac

case "$2" in
	yes)
	echo "Info : Resetting settings to factory defaults" | tee >(./logstamp)
	sudo cp -f /tce/etc/wanos/wanos.conf.default /tce/etc/wanos/wanos.conf
	sudo cp -f /tce/etc/wanos/policies.default /tce/etc/wanos/policies
	sudo cp -f /tce/etc/wanos/peersites.default /tce/etc/wanos/peersites
	sudo chown tc /tce/etc/wanos/*
	sudo chown www /tce/etc/wanos/peersites
	sudo chown www /tce/etc/wanos/policies
	test -f /tce/etc/wanos/siteslot && rm -rf /tce/etc/wanos/siteslot
	sudo rm -rf /tce/etc/wanos/wanos.click
	sudo rm -rf /tce/etc/wanos.lic
	sudo rm -rf /tce/etc/wanos/license.info
	sudo rm -rf /tce/www/stats
	cp -a /tce/www/stats-def /tce/www/stats
	sudo rm -rf /wanos/ds0/*
	sudo rm -rf /wanos/nf/l0/*
	sudo rm -rf /wanos/nf/w0/*
	/tce/etc/wanos/setdir
	;;
esac

case "$3" in
	yes)
	echo "Info : Removing Wan0 & Lan0 Interface maps" | tee >(./logstamp)
	sudo rm -rf /tce/etc/mactab
	;;
esac

case "$4" in
        yes)
	echo "Info : Clearing the datastore" | tee >(./logstamp)
        sudo rm -rf /wanos/ds0/*
	test -f /tce/etc/wanos/siteslot && rm -rf /tce/etc/wanos/siteslot
        ;;
esac

case "$5" in
	yes)
	#sudo mv -f /tce/etc/wanos/wanos.click /tce/etc/wanos/wanos.click.restore
	;;
esac

if [ "$7" != "no" ] ; then
        echo "Info : SSH & Web Interface Password Reset" | tee >(./logstamp)
	/bin/sed -i -r "s/(wanos:*).*/\1$7/" /tce/etc/.lighttpdpassword
	exit 0
fi

case "$8" in
	yes)
	echo "Info : Shutdown Requested" | tee >(./logstamp)
	sleep 1
	sudo poweroff
	;;
esac

if [ "$6" == "yes" ] ; then
	echo "Info : Reboot Requested" | tee >(./logstamp)
	sleep 1
	sudo reboot
elif [ "$2" == "yes" ] || [ "$4" == "yes" ]; then
	/tce/etc/wanos/wanos reconfigure >> /wanos/wanos.log
else	
	/tce/etc/wanos/wanos reconfigure soft >> /wanos/wanos.log
fi

