#!/usr/bin/perl
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.org/license or email info@wanos.org for more information.
#


my ($mac, $cpu) = @ARGV;

open(CONFIG, "<" , "/tce/etc/wanos/wanos.conf") || die("Couldn't open the file. Error: $!\n");
    while (<CONFIG>)
    {
    chomp;
    next if /^\s*\#/;
    next unless /=/;
    my ($key, $variable) = split(/\s*=\s*/,$_,2);
    $variable =~ s/(\$(\w+))/$config{$2}/g;
        $config{$key} = $variable;
    }
close CONFIG;


my @info=`/tce/etc/wanos/aqm.sh -num`;
foreach (@info)
{     
	 chomp;
         next if /^\s*\#/;
         next unless /=/;
         my ($key, $variable) = split(/\s*=\s*/,$_,2);
         $variable =~ s/(\$(\w+))/$info{$2}/g;
         $info{$key} = $variable;
}
my $wanop_byte = $info{BYTE};
my $wanop_queue = $info{QUEUE};
my $default_queue = $wanop_queue;

my $sim = $config{SIM};
if ($sim eq '' ) { $sim = 0; }
my @global_wan=`/tce/etc/wanos/aqm.sh -num $sim`;
   foreach (@global_wan)
	{     
	 chomp;
         next if /^\s*\#/;
         next unless /=/;
         my ($key, $variable) = split(/\s*=\s*/,$_,2);
         $variable =~ s/(\$(\w+))/$global_wan{$2}/g;
         $global_wan{$key} = $variable;
	}
 $sim = $global_wan{BYTE};
 $sim_queue = $global_wan{QUEUE};
 $default_queue = $sim_queue;


if ($config{ADAPTIVE_QUEUE} eq 'false') { $default_queue = 1000; }


$matchmac=$mac;
$matchmac=~tr/://d;

my $encapproto = "6C";
my $proto_num = 108;
if ($config{ENCAPPROTO} eq "gre")
    {
    $encapproto = "2F";
    $proto_num = 47;
    }

print <<END
//
// Switch
//
require(package "wanos_extra_packages");
require(package "wanos");
require(package "netflow");
wc::WConf(IPPROTO $proto_num, MSS $config{MSS});
tun :: KernelTap( $config{IP}/$config{MASK} , $config{GW}, ETHER $mac );
cltr :: ControlSocket(TCP, 13000, LOCALHOST true, RETRIES 3);
sw :: EtherSwitch;
END
;
print "totun :: Classifier(12/0800) -> Strip(14) -> DropBroadcasts -> encaptun :: EtherEncap(0x0800, 1:1:1:1:1:1, " . $mac . ") -> tun;\n";
print "arptable :: ARPTable;\n";
print "wanarp :: ARPQuerier(" . $config{IP} . ", " . $mac . ", TABLE arptable);\n";
print "lanarp :: ARPQuerier(" . $config{IP} . ", " . $mac . ", TABLE arptable);\n";
print "rsparp :: ARPQuerier(" . $config{IP} . ", " . $mac . ", TABLE arptable);\n";
print "elementclass SYS_Table { input -> sys_lookup::StaticIPLookup(" . $config{NET} . "/" . $config{MASK} . " 0, 0.0.0.0/0 " . $config{GW} . " 0) -> output; };\n"; 
print "sysout :: ThreadSafeQueue(" . $default_queue . ") -> Unqueue -> system_route::SYS_Table -> [0]wanarp -> [2]sw[2] -> totun;\n";
print "tun -> hostarp::Classifier(12/0800, 12/0806) -> Strip(14) -> hostcheck::CheckIPHeader -> sysout;\n";
print "hostarp[1] -> ARPResponder(0.0.0.0/0 1:1:1:1:1:1) -> tun;\n";

## Inline, Out-of-Path, PBR, Tunneled
system("perl deployment.tpl $mac");
## Post_Qos
system("perl post_qos.tpl $sim $sim_queue $wanop_byte $wanop_queue $default_queue");
## MultiSite
system("perl peersites.tpl $cpu $default_queue");
## Traffic Policies
system("perl policymap.tpl $config{MODE} $config{MSS} $sim $sim_queue $wanop_queue $config{HTTP_CACHE_REDIRECT}");


print "\n\n";
print "lan0[0]   -> class0 :: Classifier(12/0806 20/0002, 12/0806 20/0001, 12/0800 23/" . $encapproto . " 34/697A, 12/0800, -)\n";
print "class0[0] -> arpq0::Tee -> [0]sw;\n";
print "class0[1] -> arpres0::Tee -> ARPResponder(" . $config{IP} . " " . $mac . ") -> lanqueue1;\n";
print <<END
class0[2] -> peer_detect_on_lan_1::ThreadSafeQueue(1) -> DelayShaper(5) -> Print("Peer detected on lan0", CONTENTS false) -> Discard;
class0[3] -> Strip(14) -> check0::CheckIPHeader -> pass_through_broadcasts::DropBroadcasts -> lan0rx::Tee -> lprobe::PeerProbe(MODE 0, INT 1, PROBE true) -> policymap;
class0[4] -> [0]sw;
check0[1] -> unstrip0;
pass_through_broadcasts[1] -> unstrip0;
lprobe[1] -> peer_detect_on_lan_2::ThreadSafeQueue(1) -> DelayShaper(5) -> Print("Peer detected on lan0", CONTENTS false) -> Discard;

END
;
print "wan0rx1::Tee -> wanrx_c::Counter -> rtable;\n";
print "wan0rx2::Tee -> pass_through_rx::Counter -> rprobe::PeerProbe(MODE 0, INT 1, PROBE true) -> lan0policy;\n";
print "wan0[0]   -> class1 :: Classifier(12/0806 20/0002, 12/0806 20/0001, 12/0800 23/" . $encapproto . " 34/697A, 12/0800 23/11, 12/0800, -)\n";
print "class1[0] -> arpq1::Tee -> [1]sw;\n";
print "class1[1] -> arpres1::Tee -> ARPResponder(" . $config{IP} . " " . $mac . ") -> p1queue;\n";
print <<END
class1[2] -> Strip(14) -> check1::CheckIPHeader(VERBOSE $config{VERBOSE}) -> wan0rx1; 
class1[4] -> Strip(14) -> check2::CheckIPHeader(VERBOSE $config{VERBOSE}) -> wan0rx2;
class1[5] -> [1]sw;
check1[1] -> unstrip1;
check2[1] -> unstrip1;
rprobe[1] -> handlertable;
END
;
if ($config{ENCAPPROTO} ne "udp") { print "class1[3] -> Strip(14) -> check2;\n\n"; }
else {  print "class1[3] -> Strip(14) -> check3::CheckIPHeader -> class2::Classifier(9/11, -) -> reassembler1::Null -> class3::Classifier(9/11 22/0fd2 37/" . $encapproto . " 48/697A, -) -> UDPIPDecap -> MarkIPHeader -> wan0rx1;\n";
	print "class2[1] -> wan0rx2;\n";
	print "class3[1] -> wan0rx2;\n";
	print "check3[1] -> unstrip1;\n\n"; }


print "icmperr ::  ICMPError(" . $config{IP} . ", unreachable, needfrag) -> sysout;\n";
print "postfrag[1]  -> icmperr;\n";
print "prefrag[1]   -> icmperr;\n";
print <<END

udpencaplan :: UDPIPEncap(1.1.1.1, 1111, $config{IP} , 9995) -> encaptun;
udpencapwan :: UDPIPEncap(1.1.1.2, 1112, $config{IP} , 9996) -> encaptun;
lan0tx[1] -> netflow_q1::ThreadSafeQueue -> Unqueue -> Classifier(12/0800) -> Strip(14) -> CheckIPHeader -> IPClassifier((ip unfrag and tcp) or (ip unfrag and udp)) -> lantxflow :: AggregateIPFlows(TCP_TIMEOUT $config{NFTCPTIMEOUT}, FRAGMENTS false) -> NetflowExport(NOTIFIER lantxflow, VERSION 5, INTERVAL $config{NFINTERVAL}) -> udpencaplan;
lan0rx[1] -> netflow_q2::ThreadSafeQueue -> Unqueue -> IPClassifier((ip unfrag and tcp) or (ip unfrag and udp)) -> lanrxflow :: AggregateIPFlows(TCP_TIMEOUT  $config{NFTCPTIMEOUT}, FRAGMENTS false) -> NetflowExport(NOTIFIER lanrxflow, VERSION 5, INTERVAL $config{NFINTERVAL}) -> udpencaplan;
END
;

if ($config{ENCAPPROTO} ne "udp") { print "wan0tx :: ThreadSafeQueue -> Unqueue -> Classifier(12/0800) -> Strip(14) -> CheckIPHeader -> txdecap::IPCompDecap -> IPClassifier((ip unfrag and tcp) or (ip unfrag and udp)) -> wantxflow :: AggregateIPFlows(TCP_TIMEOUT $config{NFTCPTIMEOUT}, FRAGMENTS false) -> NetflowExport(NOTIFIER wantxflow, VERSION 5, INTERVAL $config{NFINTERVAL}) -> udpencapwan;\n"; }
else {  print "wan0tx :: ThreadSafeQueue -> Unqueue -> Classifier(12/0800) -> Strip(14) -> class4::Classifier(9/11 22/0fd2 37/" . $encapproto . " 48/697A, -);\n";
	print "class4[1] -> check4::CheckIPHeader -> ipdecap::IPCompDecap -> IPClassifier((ip unfrag and tcp) or (ip unfrag and udp)) -> wantxflow :: AggregateIPFlows(TCP_TIMEOUT $config{NFTCPTIMEOUT}, FRAGMENTS false) -> NetflowExport(NOTIFIER wantxflow, VERSION 5, INTERVAL $config{NFINTERVAL}) -> udpencapwan;\n";
	print "class4[0] -> UDPIPDecap -> check4;\n"; }

print <<END
wanrxflowfilter :: ThreadSafeQueue -> Unqueue -> IPClassifier((ip unfrag and tcp) or (ip unfrag and udp)) -> wanrxflow::AggregateIPFlows(TCP_TIMEOUT  $config{NFTCPTIMEOUT}, FRAGMENTS false) -> NetflowExport(NOTIFIER wanrxflow, VERSION 5, INTERVAL $config{NFINTERVAL}) -> udpencapwan;
wan0rx1[1] -> rxdecap::IPCompDecap -> wanrxflowfilter;
wan0rx2[1] -> wanrxflowfilter;
p0queue[1] -> wan0tx;
p1queue[1] -> wan0tx;
p2queue[1] -> wan0tx;
arpq0[1]     -> [1]lanarp;
arpq1[1]     -> [1]wanarp;
arpres0[1]   -> [0]sw;
arpres1[1]   -> [1]sw;
Idle -> p0queue;
Idle -> p2queue;
Idle -> [1]rsparp;
END
;
if ($config{MTHREAD} eq "BALANCE") { print "BalancedThreadSched;\n"; }

## Click Script
system("perl click_scripts.tpl $wanop_byte");

