#!/usr/bin/perl
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;
use warnings;
use Cwd qw(abs_path);
use CGI::Carp qw ( fatalsToBrowser );

use File::Basename;

$CGI::POST_MAX = 1024 * 5000;
my $safe_filename_characters = "a-zA-Z0-9_.-";
my $upload_dir = "/tce/www/stats/reports/";

my $query = new CGI;
my $update = $query->param("update"); 
my $filename = $query->param("restorefile");


open(CONFIG, "<" , "/tce/etc/wanos/wanos.conf") || die("Couldn't open the file. Error: $!\n");
    while (<CONFIG>)
    {
    chomp;
    next if /^\s*\#/;
    next unless /=/;
    my ($key, $variable) = split(/\s*=\s*/,$_,2);
    $variable =~ s/(\$(\w+))/$config{$2}/g;
        $config{$key} = $variable;
    }
close CONFIG;

if ( $filename ne '' )
{

	if ( !$filename )
	{
	print $query->header ( );
	print "There was a problem uploading the file.";
	exit;
	}

	my ( $name, $path, $extension ) = fileparse ( $filename, '..*' );
	$filename = $name . $extension;
	$filename =~ tr/ /_/;
	$filename =~ s/[^$safe_filename_characters]//g;

	if ( $filename =~ /^([$safe_filename_characters]+)$/ )
	{
	$filename = $1;
	}
	else
	{
	die "Filename contains invalid characters";
	}

	my $upload_filehandle = $query->upload("restorefile");

	open ( UPLOADFILE, ">$upload_dir/$filename" ) or die "$!";
	binmode UPLOADFILE;

	while (<$upload_filehandle>) {
    print UPLOADFILE;
	}
	autoflush UPLOADFILE 1;
	close UPLOADFILE;

	print $query->header ( );

$update = 2;
}



print <<END
<!DOCTYPE html>
<html>
<head>
  <TITLE>Backup & Restore Configuration</TITLE>
  <META HTTP-EQUIV="Cache-Control" content="no-cache">
  <META HTTP-EQUIV="Pragma" CONTENT="no-cache">
  <style>
    body { font-family: Verdana,Tahoma,Arial,Helvetica; font-size:8pt; font-weight: 500; color: 5F5F5F; margin-left:30px;}
    .header { font-size: 8pt; font-weight: 900; color: 777777 }
  </style>
<link rel="stylesheet" href="/css/base.css" type="text/css"/>
<link rel="stylesheet" href="/css/table.css" type="text/css"/>

</head>
<body bgcolor="#FDFDFC" topMargin='5'>

<br><span class='header'>Maintenance - Backup & Restore</span>
<br><br>
END
;

	if ( $update != 1 )
	{
		print <<END 
        	<table class="nav-table" style="width:840px;">                  
	        <tr><th colspan="2">Backup</th></tr><center><br><tr><td width='90%'>
	        Generate Backup Configuration File:</td>
	        <td><input type='submit' value='Submit' onclick="window.location.href='backupcfg.pl?update=1';" style='font-size: 8pt;' /></td></tr></table><br></center>
			
END
;
	}

	if ( $update == 1 )
	{

		print <<END 
        	<table class="nav-table" style="width:840px;">                  
	        <tr><th colspan="2">Backup</th></tr><center><br><tr><td width='70%'>
	        Backup Configuration File is ready for download:</td>
END
;			

			system("sudo -u tc /tce/etc/wanos/makewanoscfg.sh -backupcfg > /dev/null" );

			my @backup_files =`cd /tce/www/stats/reports/ && ls *backupcfg.tar`;
			foreach ( @backup_files )
			{
	        print "<td align='right'><a href='../stats/reports/$_' style='color:#777'>$_</a></td></tr>\n";
			}
			
			print "</table><br></center>\n";

	}
	
print <<END
	<br />
        	<table class="nav-table" style="width:840px;">                  
	        <tr><th colspan="4">Restore</th></tr><center><br><tr>
	<form action="/cgi-bin/backupcfg.pl" method="post" enctype="multipart/form-data">
	<td width='60%'>Upload and Restore Configuration File:</td>
	<td width='30%'><input type="file" name="restorefile" style='font-size: 8pt;' /></td>
	<td ><input type="submit" name="Restore" value="Restore" style='font-size: 8pt;' onclick="return confirm('Overwrite existing configs?');" />
	</td></form></tr></table><br></center><pre>
END
;

if ( $update == 2 ) { system("sudo -u tc /tce/etc/wanos/makewanoscfg.sh -restorecfg $filename" ); }

	
print <<END
<br><br>
</body>
</html>
END
;
