#!/usr/bin/perl
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;

my $cgi = CGI->new;
my $peervalue = $cgi->param("peervalue");
 
 
my @portobjs;
open(OBJ, "<" , "/tce/etc/wanos/portobjects") || die("Couldn't open the file. Error: $!\n");
    while (<OBJ>)
    {
    chomp;
    my ($key, $commastring) = split(/,/,$_,2);
    $portobjs{$key} = $commastring;
    }
close OBJ;

my %ltable = ();
my %wtable = ();
my %lptable = ();
my %wptable = ();
my %wlegend = ();
my @lpercent;
my @wpercent;
my @lport;
my @wport;

system( "sudo -u tc /tce/etc/wanos/flows 3600 ports $peervalue" );
open(LROW, "<" , "/wanos/nf/l0/ports") || die("Couldn't open the file. Error: $!\n");
while (<LROW>)
{
        chomp;
        next unless /-/;
        my @array = split(',',$_);
        push(@lpercent, $array[10]);
        my $label = (split(',',($portobjs{"$array[4]/6"})))[1];
        if ($label eq '') { $label = "TCP " . $array[4]; }
        push(@lport, $label);
        $ltable{$array[4]} = $array[9];
        $lptable{$array[4]} = $array[10];
}
close LROW;

my $i=0;
open(WROW, "<" , "/wanos/nf/w0/ports") || die("Couldn't open the file. Error: $!\n");
while(<WROW>)
{
        chomp;
        next unless /-/;
        my @array2 = split(',',$_);
        push(@wpercent, $array2[10]);
        my $label = (split(',',($portobjs{"$array2[4]/6"})))[1];
        if ($label eq '') { $label = "TCP " . $array2[4]; }
        push(@wport, $label);
        $wtable{$array2[4]} = $array2[9];
        $wptable{$array2[4]} = $array2[10];
        $wlegend{$array2[4]} = $i++;
}
close WROW;

@legendb = ( "#C8E184", "#7D9DBD", "#F9D471", "#E68080", "#94D4AA", "#FABDAD", "#C0d0FF", "#ECBDEB", "#ADDEDE", "#D7D7D7", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe",);
@legendc = ( "#D3E79D", "#6EA8C5", "#FADD8D", "#E88D8D", "#A3DAB6", "#FBCABD", "#CFE2FF", "#F0CAEF", "#BDE5E5", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe",);

		print "<script>\n";

        $i=0;
        foreach (@lpercent)
                { print "myDoughnut.addData({ value: " . $_ . ", color: '" . $legendb[$i] . "', highlight: '" . $legendc[$i] . "', label: '" . $lport[$i] . "' });\n";
                  $i++;
		  if ($i eq '5') { last; }
                }
        print "myDoughnut.update();\n";
		print "\n";

		print "\$('#proto_table > tbody:last').append(\"";

$i=0;
my @keyarray = ( sort { $lptable{$b} <=> $lptable{$a} } keys %lptable);
for ($i=0; $i < 7; $i++)
    {
	my $key = $keyarray[$i];
	($knownport, $portdesc) = split(',',$portobjs{"$key/6"});
	if ($knownport eq '') { $knownport = $key;  $portdesc = "TCP Port: " .  $knownport; }	
	print "<tr ><td title='TCP Port: " . $key . " - " . $portdesc . "'>" . $knownport . "</td><td>" . $lptable{$key} . "</td><td title='Bytes: $ltable{$key}'>" . sprintf('%.1f',$ltable{$key}/1024000) . "</td>";

	# $z = $y ? $x / $y : 0;
	my $scale = $ltable{$key} ? (($ltable{$key} - $wtable{$key})/$ltable{$key}) : 0;
	$scale = sprintf("%.1f", $scale * 100);
	if ($scale <= 0) { $scale = 0; }
	print "<td>" . "<div class='meter'><span style='width: " . $scale . "%'><div style='position:relative; left:84px; font-size:9px'>" . $scale . "%</div></span></div></td>";
	if ($wptable{$key} eq '') { $wptable{$key} = 0; }
	print "<td title='Bytes: $wtable{$key}' >" . sprintf('%.1f',$wtable{$key}/1024000) . "</td><td title='TCP Port: " . $key . " - " . $knownport . "'><center><div id='box' style='background:" . $legendc[$i] .  "'></div></center></td>";
	if ($i == 0) { print "<td rowspan='7' style='background-color:#eee'></td>";}
	print "</tr>"; 
    }

		print "\");\n";
		print "</script>";
