#!/usr/bin/perl
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#
 


print <<END
Content-type: text/html;
<!DOCTYPE html>
<html>
<head>
  <TITLE>Dashboard</TITLE>
  <style>
    body { font-family: Verdana,Tahoma,Arial,Helvetica; font-size:8pt; margin-left:30px;}
    .header1 { font-size: 8pt; font-weight: 900; color: 777777}
    .header2 { font-size: 8pt; font-weight: 900; color: 707070}
  </style>

<link rel="stylesheet" href="/css/base.css" type="text/css"/>
<style>
	#box {
	width: 13px;
	height: 13px;
	}
	
	#boxsmall {
	width: 9px;
	height: 9px;
	display: inline-block;
	}
	
	#canvas-holder{ width:30%; }

</style>


    <script src="/js/jquery.min.js"></script>
    <script src="/js/Chart.min.js"></script>
    <script>

	// Ratio Chart
	var baseurl = "live.pl";
	var typeurl = "?bytes=1";
	var graphtype = "Mbps ";
	var graphdir = "from Lan to Wan ";
	var direction = "&fromto=0";
	var peer = "&peer=";
	var refreshinterval = 3;
	var refreshtimer;
	var loss = -1;
	var wantx = 0;
	var lanrx = 0;
	var lantx = 0;
	var wanrx = 0;
	var pass_tx = 0;
	var pass_rx = 0;

	var lineChartData_TX = {
	  labels : [ "","","","","","","","","","","","","","","","","","","","","","","","","","","","","","" ],
	  datasets : [
	    {
            label: "My Second dataset",
			fillColor: "rgba(190,190,190,1)",
            strokeColor: "rgba(100,100,100,1)",
            pointColor: "rgba(100,100,100,1)",
            pointStrokeColor: "#fff",
            pointHighlightFill: "#fff",
            pointHighlightStroke: "rgba(100,100,100,1)",
			data : [ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ]
	    },
        {
			label: "MyDataset",
			fillColor : "rgba(90,120,40,0.65)",
			strokeColor : "rgba(90,120,40,1)",
			pointColor: "rgba(90,120,40,1)",
            pointStrokeColor: "#fff",
            pointHighlightFill: "#fff",
            pointHighlightStroke: "rgba(90,120,40,1)",
			data : [ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ]			
	    }
	 ]
	};

var lineChartData_RX = {
    labels: [ "","","","","","","","","","","","","","","","","","","","","","","","","","","","","","" ],
    datasets: [
        {
            label: "My First dataset",
            fillColor: "rgba(180,180,180,1)",
            strokeColor: "rgba(100,100,100,1)",
            pointColor: "rgba(100,100,100,1)",
            pointStrokeColor: "#fff",
            pointHighlightFill: "#fff",
            pointHighlightStroke: "rgba(100,100,100,1)",
            data: [ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ]
        },
        {
            label: "My Second dataset",
            fillColor: "rgba(90,120,40,0.65)",
            strokeColor: "rgba(90,120,40,1)",
            pointColor: "rgba(90,120,40,1)",
            pointStrokeColor: "#fff",
            pointHighlightFill: "#fff",
            pointHighlightStroke: "rgba(90,120,40,1)",
            data: [ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ]
        }
    ]
};
	
	
var ratio_data = {
    labels: [ "","","","","","","","","","","","","","","","","","","","","","","","","","","","","","" ],
    datasets: [
        {
            label: "My First dataset",
            fillColor: "rgba(180,180,180,1)",
            strokeColor: "rgba(100,100,100,1)",
            pointColor: "rgba(100,100,100,1)",
            pointStrokeColor: "#fff",
            pointHighlightFill: "#fff",
            pointHighlightStroke: "rgba(100,100,100,1)",
            data: [ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 ]
        },
        {
            label: "My Second dataset",
            fillColor: "rgba(90,120,40,0.65)",
            strokeColor: "rgba(90,120,40,1)",
            pointColor: "rgba(90,120,40,1)",
            pointStrokeColor: "#fff",
            pointHighlightFill: "#fff",
            pointHighlightStroke: "rgba(90,120,40,1)",
            data: [ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 ]
        }
    ]
};

var wrtt_data = {
    labels: [ "","","","","","","","","","","","","","","","","","","","","","","","","","","","","","" ],
    datasets: [
        {
            label: "My First dataset",
            fillColor: "rgba(180,180,180,1)",
            strokeColor: "rgba(100,100,100,1)",
            pointColor: "rgba(100,100,100,1)",
            pointStrokeColor: "#fff",
            pointHighlightFill: "#fff",
            pointHighlightStroke: "rgba(100,100,100,1)",
            data: [ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ]
        },
        {
            label: "My Second dataset",
            fillColor: "rgba(90,120,40,0.65)",
            strokeColor: "rgba(90,120,40,1)",
            pointColor: "rgba(90,120,40,1)",
            pointStrokeColor: "#fff",
            pointHighlightFill: "#fff",
            pointHighlightStroke: "rgba(90,120,40,1)",
            data: [ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ]
        }
    ]
};	

var LanData = [];
       
	window.onload = function(){

	// Charts
	var ctx = document.getElementById("chart-area").getContext("2d");
	window.myDoughnut = new Chart(ctx).Doughnut(LanData, {
			responsive : false,
			animationEasing : "easeOutExpo",
			animationSteps : 30,
			pointHitDetectionRadius : 6,
                        tooltipFontSize: 9,
                        tooltipYPadding: 2,
                        tooltipXPadding: 6,
                        tooltipCaretSize: 6,
                        tooltipFillColor: "rgba(0,0,0,0.4)",

			percentageInnerCutout : 63});

	var ctx = document.getElementById("canvas").getContext("2d");
	window.myLine_TX = new Chart(ctx).Line(lineChartData_TX, {
			responsive: false,
			pointDot : false,
			bezierCurveTension : 0.15,
			bezierCurve : true,
			pointDotRadius : 1,
			animation: false,
			scaleFontSize: 10,
			showTooltips: true,
			datasetStrokeWidth : 1,
			pointHitDetectionRadius : 6,
			tooltipFontSize: 9,
                        tooltipYPadding: 2,
                        tooltipXPadding: 6,
                        tooltipCaretSize: 6,
			tooltipFillColor: "rgba(0,0,0,0.4)",
			scaleBeginAtZero: true,
		});
		
	var ctx = document.getElementById("canvas1").getContext("2d");
	window.myLine_RX = new Chart(ctx).Line(lineChartData_RX, {
			responsive: false,
			pointDot : false,
			bezierCurveTension : 0.15,
			bezierCurve : true,
			pointDotRadius : 1,
			animation: false,
			scaleFontSize: 10,
			showTooltips: true,
			datasetStrokeWidth : 1,
			pointHitDetectionRadius : 6,
			tooltipFontSize: 9,
            tooltipYPadding: 2,
            tooltipXPadding: 6,
            tooltipCaretSize: 6,
			tooltipFillColor: "rgba(0,0,0,0.4)",
			scaleBeginAtZero: true,
		});

	var ctx = document.getElementById("canvas2").getContext("2d");
	window.ratio_chart = new Chart(ctx).Line(ratio_data, {
			responsive: false,
			pointDot : false,
			bezierCurveTension : 0.15,
			bezierCurve : true,
			pointDotRadius : 1,
			animation: false,
			scaleFontSize: 10,
			showTooltips: true,
			datasetStrokeWidth : 1,
			pointHitDetectionRadius : 6,
			tooltipFontSize: 9,
            tooltipYPadding: 2,
            tooltipXPadding: 6,
            tooltipCaretSize: 6,
			tooltipFillColor: "rgba(0,0,0,0.4)",
			scaleBeginAtZero: true,
		});	
		
	var ctx = document.getElementById("canvas3").getContext("2d");
	window.wrtt_chart = new Chart(ctx).Line(wrtt_data, {
			responsive: false,
			pointDot : false,
			bezierCurveTension : 0.15,
			bezierCurve : true,
			pointDotRadius : 1,
			animation: false,
			scaleFontSize: 10,
			showTooltips: true,
			datasetStrokeWidth : 1,
			pointHitDetectionRadius : 6,
			tooltipFontSize: 9,
            tooltipYPadding: 2,
            tooltipXPadding: 6,
            tooltipCaretSize: 6,
			tooltipFillColor: "rgba(0,0,0,0.4)",
			scaleBeginAtZero: true,
		});	
		
		doughnutData("");
		refreshtimer = setInterval(myUpdate, 3000);
		myUpdate();
		
};
	
	function myUpdate(timelapsed)
	{
	    updateurl =  baseurl + typeurl + direction + peer;
	   \$.ajax({
	   	dataType: "json",
		cache: false,
	   	url:updateurl,success:function(result){
		
		var wantx_diff = (result.item1 - wantx);
		var lanrx_diff = (result.item2 - lanrx);	   	
		var wanrx_diff = (result.item3 - wanrx);
		var lantx_diff = (result.item4 - lantx);
		var tx_ratio_fixed = (lanrx_diff/wantx_diff).toFixed(2);
		var rx_ratio_fixed = (lantx_diff/wanrx_diff).toFixed(2);
		
		if (wantx_diff > 0 && wanrx_diff > 0 && lantx_diff > 0 && lanrx_diff > 0 )
		{	

//			document.getElementById("graphinterval_ratio").innerHTML = tx_ratio_fixed + rx_ratio_fixed;
			ratio_chart.addData([ rx_ratio_fixed, tx_ratio_fixed], "" );
			ratio_chart.removeData();
			
				if (lanrx > 0 && wantx > 0)
				{
				var txps = (wantx_diff/refreshinterval)/125000;
				var rxps = (lanrx_diff/refreshinterval)/125000;
				myLine_TX.addData([rxps.toFixed(2), txps.toFixed(2)], "");
				myLine_TX.removeData();
				
				txps = (wanrx_diff/refreshinterval)/125000;
				rxps = (lantx_diff/refreshinterval)/125000;
				myLine_RX.addData([rxps.toFixed(2), txps.toFixed(2)], "");
				myLine_RX.removeData();
				}
			
		}
		else
		{
			myLine_TX.addData([0, 0], "");
			myLine_TX.removeData();
			myLine_RX.addData([0, 0], "");
			myLine_RX.removeData();
			ratio_chart.addData([1, 1], "");
			ratio_chart.removeData();
		}
		

		
		if ( peer == "&peer=" )
		{
		var pass_tx_diff = (result.item5 - pass_tx);
		var pass_rx_diff = (result.item6 - pass_rx);
		
		if ( pass_tx_diff < 0 ) { pass_tx_diff = 0; }
		if ( pass_rx_diff < 0 ) { pass_rx_diff = 0; }
			if ( pass_tx > 0 && pass_rx > 0 )
			{
				txps = (pass_tx_diff/refreshinterval)/125000;
				rxps = (pass_rx_diff/refreshinterval)/125000;
				wrtt_chart.addData([rxps.toFixed(2), txps.toFixed(2)], "");
				wrtt_chart.removeData();
			}
		}
		else
		{
			if ( loss >= 0 )
			{
			var loss_diff = ( result.item5 - loss);
			if ( loss_diff < 0 ) { loss_diff = 0; }
			wrtt_chart.addData([loss_diff, result.item6 ], "");
			wrtt_chart.removeData();
			}
		}
		
		loss = result.item5;
		if (result.item5 > 0 ) { pass_tx = result.item5; } else { pass_tx = 0; }
		if (result.item6 > 0 ) { pass_rx = result.item6; } else { pass_rx = 0; }
		
		if (result.item1 > 0 ) { wantx = result.item1; } else { wantx = 0; }
		if (result.item2 > 0 ) { lanrx = result.item2; } else { lanrx = 0; }
		if (result.item3 > 0 ) { wanrx = result.item3; } else { wanrx = 0; }
		if (result.item4 > 0 ) { lantx = result.item4; } else { lantx = 0; }
		
		//document.getElementById("graphnum").innerHTML = updateurl;
	    	   }});
	}


        function livegraphrate(optionvalue)
        {
	clearInterval(refreshtimer);
	refreshtimer =  setInterval(myUpdate, optionvalue);
	refreshinterval = (optionvalue / 1000);	
	graphinterval = "in " + refreshinterval + " sec intervals";
	document.getElementById("graphinterval_tx").innerHTML = graphinterval;
	document.getElementById("graphinterval_rx").innerHTML = graphinterval;
	document.getElementById("graphinterval_ratio").innerHTML = graphinterval;
	document.getElementById("graphinterval_rtt").innerHTML = graphinterval;
	}

	function setpeer(peervalue)
    {
		peer = "&peer=" + peervalue;
		for (i = 0; i < 30 ; i++)
			{ myLine_TX.datasets[0].points[i].value = 0; 
			  myLine_TX.datasets[1].points[i].value = 0;
			  myLine_RX.datasets[0].points[i].value = 0;
			  myLine_RX.datasets[1].points[i].value = 0;
			  wrtt_chart.datasets[0].points[i].value = 0;
			  wrtt_chart.datasets[1].points[i].value = 0;
			  ratio_chart.datasets[0].points[i].value = 1;
			  ratio_chart.datasets[1].points[i].value = 1;
			}
			
		loss = -1;
		pass_tx = 0;
		pass_rx = 0;
		wantx = 0;
		lanrx = 0;
		wanrx = 0;
		lantx = 0;

		myLine_TX.update();
		myLine_RX.update();
		wrtt_chart.update();
		ratio_chart.update();
		
		var stats_for;
		
		if (peervalue == "")
		{ peervalue = ""; 
		  graph_desc = "Pass-Through Mbps Wan Tx <div id='boxsmall' style='background:#999'></div> Wan Rx <div id='boxsmall' style='background:#70944D'></div>";
		  stats_for = "Total";
		  doughnutData("");
		}
		else
		{ graph_desc = "Loss Recovery <div id='boxsmall' style='background:#999'></div> Latency RTT ms <div id='boxsmall' style='background:#70944D'></div> to Peer:";
		  stats_for = "Peer " + peervalue;
		  doughnutData(peervalue);
		}
		
		document.getElementById("graphrtt").innerHTML = graph_desc;
		document.getElementById("peer_rtt").innerHTML = peervalue;
		document.getElementById("opt_graphs_for").innerHTML = stats_for;
		document.getElementById("apps_stats_for").innerHTML = stats_for;
		
	}
	
  
	function doughnutData(peervalue)
    {
		\$("#proto_table > tbody:last").children().remove();
		myDoughnut.removeData();
		myDoughnut.removeData();
		myDoughnut.removeData();
		myDoughnut.removeData();
		myDoughnut.removeData();
	
	  \$.ajax({
		type: "POST",
		url: "/cgi-bin/chartdata.pl?peervalue=" + peervalue,
		data: "{}",
		success: function( returnedData ) {
		\$( '#chartdata_table' ).html( returnedData );
		}
	  })
	  
	  
	}

</script>

</head>
<body bgcolor="#FDFDFC" topMargin='5'>
<br>
<table class="nav-table" style="width:840px; height:460px;">
<tr><th >Live Graphs :  <span id="opt_graphs_for">Total</span></th></tr> 
<tr><td>
	<table>
	<tr >
	<td width="15%" >Display : </td>
	<td width="20%" >Peer:<br><select name="main" style="font-size: 8pt; width:70px"  onchange="setpeer(this.value)">
	<option value="">Total</option>
	<option value="0">Peer 0</option>
	<option value="1">Peer 1</option>
	<option value="2">Peer 2</option>
	<option value="3">Peer 3</option>
	<option value="4">Peer 4</option>
	<option value="5">Peer 5</option>
	<option value="6">Peer 6</option>
	<option value="7">Peer 7</option>
	<option value="8">Peer 8</option>
	<option value="9">Peer 9</option>
	<option value="10">Peer 10</option>
	<option value="11">Peer 11</option>
	<option value="12">Peer 12</option>
	<option value="13">Peer 13</option>
	<option value="14">Peer 14</option>
	<option value="15">Peer 15</option>
	<option value="16">Peer 16</option>
	</select></td>
	<td >Interval:<br><span><select onchange="livegraphrate(this.value)" style="width:70px; font-size: 8pt""><option value='3000'>3 Seconds</option><option value='10000'>10 Seconds</option><option value='30000'>30 Seconds</option></select></span></td>
	</tr>
	</table>

</td></tr>
<tr><td>
    <div style="width:370px; height:200px; float:left; margin-left:30px">
    <canvas id="canvas" width="370" height="150" style="width:370px; height:150px"></canvas>
    <center>
    <span id="graphdir">Optimized Mbps from Lan <div id='boxsmall' style='background:#999'></div> to Wan <div id='boxsmall' style='background:#70944D'></div> </span>
    <span id="graphinterval_tx">in 3 sec intervals</span>
    </center>
    </div>

    <div style="width:370px; height:200px; float:right; margin-right:30px"">
    <canvas id="canvas1" width="370" height="150" style="width:370px; height:150px"></canvas>
    <center>
    <span id="graphdir">Optimized Mbps from Wan <div id='boxsmall' style='background:#70944D'></div> to Lan <div id='boxsmall' style='background:#999'></div> </span>
    <span id="graphinterval_rx">in 3 sec intervals</span>
    </center>
    </div>


<br />
</td></tr>
<tr><td>

    <div style="width:370px; height:170px; float:left; margin-left:30px; ">
    <canvas id="canvas2" width="370" height="150" style="width:370px; height:150px"></canvas>
    <center>
    <span >Ratio: Wan Rx <div id='boxsmall' style='background:#999'></div> Wan Tx <div id='boxsmall' style='background:#70944D'></div> </span>
    <span id="graphinterval_ratio">in 3 sec intervals</span>
    </center>
    </div>

    <div style="width:370px; height:170px; float:right; margin-right:30px"">
    <canvas id="canvas3" width="370" height="150" style="width:370px; height:150px"></canvas>
    <center>
    <span id="graphrtt">Pass-Through Mbps Wan Tx <div id='boxsmall' style='background:#999'></div> Wan Rx <div id='boxsmall' style='background:#70944D'></div></span>
    <span id="peer_rtt"></span>
    <span id="graphinterval_rtt">in 3 sec intervals</span>
    </center>
    </div>
	
<br />

<span id="graphnum"></span></center>
<br />
</td></tr></table> 
<br>

	<table style="width:840px; position:relative; top:10px" class="striped sortable" id="proto_table" title="Top protocols in the last hour"> 

	<thead><tr><th>Application</th><th>LAN Traffic %</th><th>LAN MB</th><th width='20%'>Optimization</th><th>WAN MB</th><th>Legend</th><th style="width:200px">Chart: <span id="apps_stats_for">Total</span></th></tr></thead><tbody> 
	<div id='chartdata_table' title="Top protocols in the last hour"></div> 
	</tbody>
	</table>

	    <div id="canvas-holder" style="position:relative; top:-180px; left:645px; width:200px; height:200px;" >
		<canvas id="chart-area" width="170" height="170"></canvas>
	    </div>

<br>



</body>
</html>
END
;
