#!/usr/bin/perl
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;
use warnings;

print "Content-type: text/html;\n\n";

my @graphs;
my $cgi = CGI->new;
my $name = $cgi->param("trend");
my $desc = $cgi->param("desc");
my $time = $cgi->param("time");
my $export = $cgi->param("export");
my $maingraph = $cgi->param("main");
my $maingraphvalue = lc $maingraph;
$maingraphvalue=~ s/\s//g;
if ($time eq '') { $time = 'Day'; }
my $timename;
if ($time eq 'Hour') { $timename = "Last Hour"; }
if ($time eq 'Day') { $timename = "Last Day"; }
if ($time eq 'Week') { $timename = "Last Week"; }
if ($time eq 'Month') { $timename = "Last Month"; }
if ($time eq 'Year') { $timename = "Last Year"; }

if ($maingraph eq '') { $maingraph = 'Total'; }
if ($maingraph eq 'Total')
{ push (@graphs, "total-rate,Total Optimized Traffic", "total-passthrough, Total Pass-Through", "total-ratio,Total Ratio"); }
else
{ push (@graphs, "$maingraphvalue-rate,$maingraph : Traffic", "$maingraphvalue-ratio,$maingraph : Ratios"); }

if ( $export eq 'pdf' )
{
open (OUT, ">/tce/www/stats/reports/optimization.html") or die "Can't open OUT: $!";
$url="/tce/www";
}
else { open (OUT, ">&STDOUT") or die "Can't open OUT: $!"; }

print OUT <<END
<!DOCTYPE html>
<html>
<head>
  <TITLE>Network Traffic Saved</TITLE>
  <META HTTP-EQUIV="Refresh" CONTENT="300">
  <META HTTP-EQUIV="Cache-Control" content="no-cache">
  <META HTTP-EQUIV="Pragma" CONTENT="no-cache">
  <style>
    body { font-family: Verdana,Tahoma,Arial,Helvetica; font-size:8pt; margin-left:30px;}
    .header { font-size: 8pt; font-weight: 900; color: 777777 }
  </style>
<link rel="stylesheet" href="$url/css/base.css" type="text/css"/>
</head>
<body bgcolor="#FDFDFC" topMargin='5'>

<br><span class='header'>Optimization</span>
<br><br>
<form action="freetraf.pl" method="post">
<table class="nav-table" style="width:840px;">
<tr><th colspan="5">Display Options</th></tr>
<tr><td>

	<td>Peer:<br><select name="main"  onchange="this.form.submit()">
	<option value="$maingraph">$maingraph</option>
	<option value="Total">Total</option>
	<option value="Peer 0">Peer 0</option>
	<option value="Peer 1">Peer 1</option>
	<option value="Peer 2">Peer 2</option>
	<option value="Peer 3">Peer 3</option>
	<option value="Peer 4">Peer 4</option>
	<option value="Peer 5">Peer 5</option>
	<option value="Peer 6">Peer 6</option>
	<option value="Peer 7">Peer 7</option>
	<option value="Peer 8">Peer 8</option>
	<option value="Peer 9">Peer 9</option>
	<option value="Peer 10">Peer 10</option>
	<option value="Peer 11">Peer 11</option>
	<option value="Peer 12">Peer 12</option>
	<option value="Peer 13">Peer 13</option>
	<option value="Peer 14">Peer 14</option>
	<option value="Peer 15">Peer 15</option>
	<option value="Peer 16">Peer 16</option>
	</select></td>
	<td>Period:<br> <select name="time" >
	<option value="$time">$timename</option>
	<option value="Hour">Last Hour</option>
	<option value="Day">Last Day</option>
	<option value="Week">Last Week</option>
	<option value="Month">Last Month</option>
	<option value="Year">Last Year</option>
	</select></td>
	<td>Export:<br><select name="export" >
	<option></option><option value="pdf">&nbsp;PDF&nbsp;</option>
	</select></td>
	<td align='left'><br><input type='submit' value='Go' style="font-size: 8pt"></td>
</tr></center>
</table>
</form>
END
;

	print OUT "<br>";
if ($name eq '')
{
	foreach $graph (@graphs)
	{
	    ($graphname, $desc) = split(',', $graph);
	    print OUT "<table class='graph-table' style='width:840px'><tr><th>$desc</th></tr><tr><td><div style='margin-left:90px'>";
	    my $filename = "../stats/$graphname-$time.png";
	    if (-r $filename)
	    { print OUT "<a href='?trend=$graphname&desc=$desc'><img src='$url/stats/$graphname-$time.png' border='0'><br></a></div></td></tr></table><br>"; }
	    else
	    { print OUT "No Data<br></div></td></tr></table><br>\n"; }
	}
}
else
{
	foreach $period ("Hour", "Day", "Week", "Month", "Year")
	{
	print OUT "<table class='graph-table' style='width:840px'><tr><th>$desc : $period</th></tr><tr><td><div style='margin-left:90px'><img src='$url/stats/$name-$period.png' border='0'><br></div></td></tr></table><br>\n";
	}
}

print OUT <<END
<br><br>
</div></body>
</html>
END
;

close OUT;

if ( $export eq 'pdf' )
{
 system("/tce/packages/click/exporttool /tce/www/stats/reports/optimization.html /tce/www/stats/reports/optimization.pdf" );
 print <<END
        <html>
        <head><link rel="stylesheet" href="/css/base.css" type="text/css"/></head>
        <body bgcolor="#FDFDFC" topMargin='5'>
        <br><span class='header'>Optimization Report</span>
        <br><br>
        <table class='nav-table' style="width:840px;">
        <tr><th>Report Ready</th></tr><center><br><tr><td>
        Optimization report is ready for download:
        <a href='../stats/reports/optimization.pdf' style='color:#777'>Optimization stats for $maingraph from the $timename</a></td></tr><br></center></table>
        </body></html>
END
;
}

