#!/usr/bin/perl
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#
 

use CGI;
use warnings;
use autodie;
use Scalar::Util qw(looks_like_number);

print "Content-type: text/html;\n\n";

my $cgi = CGI->new;
my $policy = $cgi->param("policy");
my $dstnet = $cgi->param("dstnet");
my $sitenum = $cgi->param("sitenum");
my $sitename = $cgi->param("sitename");
my $remove = $cgi->param("remove");
my $peerip = $cgi->param("peerip");
my $update = 0;
my $paramerror = 0;
my $removed = 0;
my $errmsg = "";
my @dst = ();

if ($policy ne '') { $update = 1;}
if (($policy < 1) || ($policy > 100 )) { $policy = 101;}
if ($dstnet eq '') { $dstnet = "0.0.0.0/0";}

my $disabled = "";
my $status = (split "=", `head -1 /tce/etc/wanos/license.info`)[1];
chomp($status);
if ($status eq 'Unlicensed') { $disabled = "disabled"; }

my $disksize;
my $diskrequired;
my $datastore;
my $totalmem;

my @rows;
my %sites;
my $i = 0;

open(ROW, "<" , "/tce/etc/wanos/peersites") || die("Couldn't open the file. Error: $!\n");
    while (<ROW>)
    {
    chomp;
    next if /^\s*\#/;
    next unless /=/;
    my ($key, $commastring) = split(/\s*=\s*/,$_,2);
    $commastring =~ s/(\$(\w+))/$rows{$2}/g;
        $rows{$key} = $commastring;
	my @values = split(',',$commastring);
    	$sites{$values[1]} = 1;
        $i++;
    }
close ROW;
my $totalsites=scalar keys %sites;


my @config;
open(CONFIG, "<" , "/tce/etc/wanos/wanos.conf") || die("Couldn't open the file. Error: $!\n");
    while (<CONFIG>)
    {
    chomp;
    next if /^\s*\#/;
    next unless /=/;
    my ($key, $variable) = split(/\s*=\s*/,$_,2);
    $variable =~ s/(\$(\w+))/$config{$2}/g;
        $config{$key} = $variable;
    }
close CONFIG;
$datastore=($config{DS_SIZE}/1000);
$datastore_mem=($config{DS_SIZE}/16)*1000;
$cache_size=$config{HTTP_CACHE_SIZE}/1000;
$cache_mem=$config{HTTP_CACHE_MEM}*1000;

# Skip rules if the values are suspect
if ($update == 1)
{
 @dst = split(/\//, $dstnet);
 my $ipno = qr/2(?:5[0-5]|[0-4]\d)|1\d\d|[1-9]?\d/x;
 if ( $dst[0] !~ /^($ipno\.){3}$ipno$/ ) { $update = 0; $paramerror = 2;}
 if (!looks_like_number($dst[1])) { $update = 0; $paramerror = 3;}
 if (( $dst[1] > 32) || ( $dst[1] < 0 )) { $update = 0; $paramerror = 3;}
# if ($totalsites > 5) { $update = 0; $paramerror = 4;} 
 $totalmem=(split " ", `head -1 /proc/meminfo`)[1];
 $memrequired = ($totalsites * $datastore_mem);
 if ( $memrequired >= $totalmem ) { $update = 0; $paramerror = 5;}
 if (( $peerip ne ``) && ( $peerip !~ /^($ipno\.){3}$ipno$/ )) { $update = 0; $paramerror = 6;}

 $sitename =~ s/,//g; 
}



if ($update == 1)
{
 foreach my $check (keys %rows) 
 {
  if ($check == $policy) { $update = 0; $paramerror = 8;}
 }
}


if ($update == 1)
{
	open(OUT, ">>" , "/tce/etc/wanos/peersites") || die("Couldn't open the file. Error: $!\n");
	my $updatestring = "$policy" . "=" . "$dst[0]/$dst[1],$sitenum,$sitename,$peerip";
	print OUT $updatestring . "\n";
	($key, $commastring) = split(/\s*=\s*/,$updatestring,2);
	$commastring =~ s/(\$(\w+))/$rows{$2}/g;
	$rows{$key} = $commastring;
	$i++;
	close OUT;


        open(OUT, ">" , "/tce/etc/wanos/reconfigure") || die("Couldn't open the file. Error: $!\n");
        print OUT "1";            
        close OUT;
}


if (($remove ne '') && (looks_like_number($remove)))
{
	open(OUT, ">" , "/tce/etc/wanos/peersites") || die("Couldn't open the file. Error: $!\n");
	foreach my $num (keys %rows)
        {
            $line = $num . "=" . "$rows{$num}" . "\n";
            print OUT $line  unless ( $line =~ m/^$remove=/ );
        }
	close(OUT);
        $removed = $remove;


        open(OUT, ">" , "/tce/etc/wanos/reconfigure") || die("Couldn't open the file. Error: $!\n");
        print OUT "1";            
        close OUT;
}




print "<!DOCTYPE html>\n<html>\n<head>\n<TITLE>Peer Site Policies</TITLE>";

print <<EOF;
  <META HTTP-EQUIV="Cache-Control" content="no-cache">
  <META HTTP-EQUIV="Pragma" CONTENT="no-cache">
  <style>
     body { font-family: Verdana,Tahoma,Arial,Helvetica; font-size:8pt; font-weight: 500; color: 5F5F5F; margin-left:30px;}
     table { font-size: 8pt; font-weight: 500; color: 5F5F5F }
    .header { font-size: 8pt; font-weight: 900; color: 777777 }
     a:link { color: #5F5F5F;}
     a:visited { color: #5F5F5F;}
  </style>
<link rel="stylesheet" href="/css/table.css" type="text/css"/>
<link rel="stylesheet" href="/css/base.css" type="text/css"/>
</head>
<body bgcolor="#FDFDFC" topMargin='5'>

<br><span class='header'>MultiSite Policies</span>
<br><br>
<div style="width:840px;" >
                <table class="striped sortable">
		    <thead>
                    <tr>
                        <th width='15%'>
                            Rule #
                        </th>
                        <th width='20%' title='Remote Site Network Subnets'>
                           Remote Site Subnet
                        </th>
                        <th width='15%' title='Group Multiple Subnets together'>
                           Site Number
                        </th>
                        <th width='20%' title='Optional Remote Peer IP Address&#013;For Example: 10.10.20.254'>
                           Peer IP
                        </th>
                        <th width='20%' title='Name, Comment or Description'>
                           Description
                        </th>
                        <th width='15%' title='Remove this rule'>
                           Delete 
                        </th>
                    </tr>
		   </thead>
EOF

foreach (sort { $a <=> $b } keys(%rows) )
{
 next if $_ == $removed;
 my @values = split(',',$rows{$_});
 print  "<tr><td><center>$_</center></td><td title='Remote Site Network Subnet'>$values[0]</td><td title='Group Multiple Subnets together'><center>$values[1]</center></td><td title='Optional Remote Peer IP Address&#013;For Example: 10.10.20.254'>";
 if ( $values[3] eq '' ) { print "Auto"; }
 else { print $values[3]; }
 print "</td><td title='Name, Comment or Description'>$values[2]</td>\n";
 if ($_ < 100) { print  "<td><center><div title='Remove this rule'><a href='peersites.pl?remove=$_' style='color:5F5F5F'><img src='/images/delete-16.png' border='0' /></a></div></center></td></tr>\n"; }
 elsif ($_ == 100) { print  "<td><center><div title='Remove this rule'><a href='peersites.pl?remove=$_' style='color:5F5F5F'><img src='/images/delete-16.png' border='0' onclick='return confirm(\"The default rule is essential. Removing this rule without replacing it with an equivalent default will result in failure. Continue?\");'  /></a></div></center></td></tr>\n"; }
 else { print "<td> </td></tr>\n"; }
}
print "</table></div>\n";

$i++;

print <<EOF;            
<br><form action="peersites.pl" name="addrule" method="post">
<fieldset style="width: 840px;">
<legend>Add Site</legend>
<table width="840px">
<tr>
<td align="center" width='15%'><input name="policy" title="Rule Number (1-100)" type="number" value="$i" min="1" max="100" size="3" style="font-size: 8pt; " /></td>
<td align="center" width='20%'><input name="dstnet" title="Remote Site Network & Mask" type="text" size="20" maxlength="20" style="font-size: 8pt" /></td>
<td align="center" width='15%'><select name="sitenum" title="Group Multiple Subnets together" style="font-size: 8pt; width:60px">
EOF
;

print "<option value='0'>0</option>\n"; 
for ($c = 1; $c <= 64; $c++) { print "<option value='$c' $disabled>$c</option>\n"; }

print <<EOF;
</select></td>
<td align="center" width='20%'><input name="peerip" title="Optional Remote Peer IP Address&#013;For Example: 10.10.20.254" type="text" size="20" maxlength="15" style="font-size: 8pt" /></td>
<td align="center" width='20%'><input name="sitename" title="Site Name, Comment or Description" type="text" size="20" maxlength="40" style="font-size: 8pt" /></td>
<td align="center" width='10%'><input type="submit" value="Add" size="3" style="font-size: 8pt"></td>
</tr></table>
</fieldset>
</form>
EOF


if ( $update == 1 ) { print "Peer Site Policy updated. Apply the new policy by restarting the Wanos service under <a target='_parent' href='/reset.html'>Configure > Reset</a><br />\n";}     
if ( $paramerror == 1 ) { print "Invalid Source Network<br />\n";}
if ( $paramerror == 2 ) { print "Invalid Destination Network<br />\n";}
if ( $paramerror == 3 ) { print "Invalid Network Mask<br />\n";}
if ( $paramerror == 4 ) { print "Could not add site. 32-Bit platform supports a maximum of 4 peers<br />\n";}
if ( $paramerror == 5 ) { print "Insufficient memory for additional remote site: $totalsites remote sites requires $totalsites GB.<br />\n";}
if ( $paramerror == 6 ) { print "Invalid Remote Peer IP Address.<br />\n";}
if ( $paramerror == 7 ) { print "Shape requires a Rate<br />\n";}
if ( $paramerror == 8 ) { print "Duplicate Rule Number<br />\n";}
if ( $paramerror == 9 ) { print $errmsg . "<br />\n";}
if ( $removed > 0) { print "Rule # " . $removed . " removed. Apply the new policy by restarting the Wanos service under <a target='_parent' href='/reset.html'>Configure > Reset</a><br /><br />\n";}
if ( $removed == 100 ) { print "<span style='color:red;'>Warning : Removing the default site is not recommended. Please add a default catch all site.</span><br /> <br />\n";}

my %sites;
open(SITES, "<" , "/tce/etc/wanos/peersites") || die("Couldn't open the file. Error: $!\n");
    while (<SITES>)
    {
    chomp;
    next if /^\s*\#/;
    next unless /=/;
    my @values = split(/,/,$_);
    $sites{$values[1]} = 1;
    }
close SITES;
$totalsites=scalar keys %sites;


 if ($totalsites == 0) {  print "<span style='color:red;'>Warning : No remote site subnets configured. The default subnet is required.</span><br />\n";}
 $disksize = `df -h /wanos | tail -1`;
 @disksize = split(' ',$disksize);
 $disksize = $disksize[1];
 if ( $disksize =~ /T/ ) { $disksize = $disksize * 1024; }
 if ( $disksize =~ /M/ ) { $disksize = $disksize / 1024; }
 $diskrequired = $totalsites * $datastore;
 if ($config{HTTP_CACHE_REDIRECT} eq 'true') { $diskrequired = $diskrequired + $cache_size; }
 if ($diskrequired >= $disksize) {  print "<span style='color:red;'>Warning : Insufficient disk space on partition ($disksize Available). Expand or add partition ($diskrequired GB Required).</span><br />\n";}

 $totalmem=(split " ", `head -1 /proc/meminfo`)[1];
 $memrequired = ($totalsites * $datastore_mem);
 if ($config{HTTP_CACHE_REDIRECT} eq 'true') { $memrequired = $memrequired + $cache_mem; }
 if ( $memrequired >= $totalmem ) { print "<span style='color:red;'>Warning : Insufficient RAM Memory ($totalmem KB Available - $memrequired KB Required).</span><br />\n";}
print "<br><br>\n</body>\n</html>\n";
