#!/usr/local/bin/perl -w
#
# Copyright (c) 2010-2014 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;
use IO::Socket;
use warnings;

my $cgi = CGI->new;

open(ROW, "<" , "/tce/etc/wanos/peersites") || die("Couldn't open the file. Error: $!\n");
while (<ROW>)
{
        chomp;
        next if /^\s*\#/;
        next unless /=/;
        my ($key, $commastring) = split(/\s*=\s*/,$_,2);
        $commastring =~ s/(\$(\w+))/$rows{$2}/g;
        $rows{$key} = $commastring;
        my @values = split(',',$commastring);
        $sites{$values[1]} = $values[2];
}
close ROW;

my $getstatus = $cgi->param("getstatus"); 
if ( $getstatus eq '1')
{
	my %stats = ();
	my $data;
	my @vars;
        autoflush STDOUT 1;
#        printf "Status: 200\r\n\r\n";
	print "Content-type: text/json;\n\n";

	print "{\n";
	foreach (keys %sites)
		{
		$data = `/tce/etc/wanos/wanos-stats 2h peer$_ peerlanrx peer$_ peerwantx`;
		chomp($data);
		@vars = ();
		@vars = split(' ',$data);
		if (($vars[2] > 0) && ($vars[1] > 0))
		    { 
		      my $ratio = sprintf("%.0f", (($vars[1]-$vars[2])/$vars[1])*100);		
		      if ($ratio < 0) { $ratio = 0; }
	              print "    \"peer_tx_ratio$_\": \"$ratio%\",\n";
		    }

		$data = `/tce/etc/wanos/wanos-stats 2h peer$_ peerlantx peer$_ peerwanrx`;
		chomp($data);
		@vars = ();
		@vars = split(' ',$data);
		if (($vars[2] > 0) && ($vars[1] > 0))
		    { 
		      my $ratio = sprintf("%.0f", (($vars[1]-$vars[2])/$vars[1])*100);		
		      if ($ratio < 0) { $ratio = 0; }
	              print "    \"peer_rx_ratio$_\": \"$ratio%\",\n";
		    }

		}

	my @data;	
	my $socket;
	$socket = IO::Socket::INET->new(PeerAddr => 'localhost', PeerPort => '13000', Proto => 'tcp',) or die("Error :: $! ");

	foreach (keys %sites)
		{
		 print($socket "read bypass$_.active\r\n");
		 print($socket "#\r\n");
		}
	print($socket "quit\r\n");
	@data = ();
	@data = <$socket>;
	my $datanum = scalar @data;
	for (my $i = 0; $i < $datanum; $i++)
		{
		next unless $data[$i] =~ /bypass.*OK/;
		my @bypass = split('\'',$data[$i]);
		$bypass[1] = (substr($bypass[1],0, -7));
		(my $data, my $len) = split(' ',$data[$i+1], 2);
		$data = (substr($data[$i+2],0, $len));
		if ( $data eq 'true') { $data = 'Down'; }
		if ( $data eq 'false') { $data = 'Up'; }
		print "    \"$bypass[1]\": \"$data\",\n";
		}
	close($socket);

	$socket = IO::Socket::INET->new(PeerAddr => 'localhost', PeerPort => '13000', Proto => 'tcp',) or die("Error :: $! ");

	foreach (keys %sites)
		{
		 print($socket "read dedup$_.ds_ready\r\n");
		 print($socket "#\r\n");
		}
	print($socket "quit\r\n");
	@data = ();
	@data = <$socket>;
	$datanum = scalar @data;
	for (my $i = 0; $i < $datanum; $i++)
		{
		next unless $data[$i] =~ /dedup.*OK/;
		my @dedup = split('\'',$data[$i]);
		$dedup[1] = (substr($dedup[1],0, -9));
		(my $data, my $len) = split(' ',$data[$i+1], 2);
		$data = (substr($data[$i+2],0, $len));
		if ( $data eq '0') { $data = 'Loading'; }
		if ( $data eq '1') { $data = 'Ready'; }
		print "    \"$dedup[1]\": \"$data\",\n";
		}
	close($socket);

	$socket = IO::Socket::INET->new(PeerAddr => 'localhost', PeerPort => '13000', Proto => 'tcp',) or die("Error :: $! ");

	foreach (keys %sites)
		{
		 print($socket "read comp$_.active_method\r\n");
		 print($socket "#\r\n");
		}
	print($socket "quit\r\n");
	@data = ();
	@data = <$socket>;
	$datanum = scalar @data;
	for (my $i = 0; $i < $datanum; $i++)
		{
		next unless $data[$i] =~ /comp.*OK/;
		my @plr = split('\'',$data[$i]);
		$plr[1] = (substr($plr[1],0, -14));
		(my $data, my $len) = split(' ',$data[$i+1], 2);
		$data = (substr($data[$i+2],0, $len));
		if ( $data eq 'Streaming') { $data = 'On'; }
		if ( $data eq 'Stateless') { $data = 'Off'; }
		print "    \"$plr[1]\": \"$data\",\n";
		}
	close($socket);


	print "    \"item0\": \"0\"\n}\n";
	print "  \n";
	print "  \n";
	autoflush STDOUT 1;
	exit;
}

print "Content-type: text/html;\n\n";
print <<END
<!DOCTYPE html>
<html>
<head>
  <TITLE>Connected Peers</TITLE>
  <style>
    body { font-family: Verdana,Tahoma,Arial,Helvetica; font-size:8pt; margin-left:30px;}
    .header1 { font-size: 8pt; font-weight: 900; color: 777777}
    .header2 { font-size: 8pt; font-weight: 900; color: 707070}
  </style>
<link rel="stylesheet" href="/css/base.css" type="text/css"/>
<style>
        table.z { border:0; border-collapse: collapse;}
        table.z tbody tr:nth-child(odd) { background-color: #eee; }
        table.z td { padding: 3 3 3 3 }
        table.z th { text-align:left; color: #777; font-size:10px}

	#canvas-holder{ width:30%; }
</style>
    <script src="/js/jquery.min.js"></script>
    <script>
	window.onload = function(){ refreshtimer = setInterval(myUpdate, 60000);
	myUpdate();
	};

	function myUpdate()
	{
	   \$.ajax({
	   	dataType: "json",
		cache: false,
	   	url:'peerstatus.pl?getstatus=1',success:function(result){
END
;
	foreach (keys %sites) { print "if ( typeof result.bypass$_ !== 'undefined' ) { document.getElementById('bypass$_').textContent = result.bypass$_; } \n";  }
	foreach (keys %sites) { print "if ( typeof result.dedup$_ !== 'undefined' ) { document.getElementById('ds_ready$_').textContent = result.dedup$_; } \n"; }
	foreach (keys %sites) { print "if ( typeof result.peer_rx_ratio$_ !== 'undefined' ) { document.getElementById('peer_rx_ratio$_').textContent = result.peer_rx_ratio$_; } \n"; }
	foreach (keys %sites) { print "if ( typeof result.peer_rx_ratio$_ !== 'undefined' ) { document.getElementById('meter_rx$_').style.width = result.peer_rx_ratio$_; } \n"; }
	foreach (keys %sites) { print "if ( typeof result.peer_tx_ratio$_ !== 'undefined' ) { document.getElementById('peer_tx_ratio$_').textContent = result.peer_tx_ratio$_; } \n"; }
	foreach (keys %sites) { print "if ( typeof result.peer_tx_ratio$_ !== 'undefined' ) { document.getElementById('meter_tx$_').style.width = result.peer_tx_ratio$_; } \n"; }

	foreach (keys %sites) { print "if ( typeof result.comp$_ !== 'undefined' ) { document.getElementById('plr_status$_').textContent = result.comp$_; } \n"; }

print <<END
	    	   }});
	}

    </script>
</head>
<body bgcolor="#FDFDFC" topMargin='5'>
<br><span class='header'>Connected Peers</span>
<br><br><div style='width:840px;'>
<table class="striped sortable">
<thead><tr><th width='8%'>Site #</th><th width='25%'>Site Name</th><th width='11%'>Local Status</th><th width='11%'>Peer Status</th><th width='8%' title='Packet Loss Recovery and Packet Order Correction'>PLR</th><th width='15%' title='Rx Reduction the last 2h' >Wan Rx Reduction</th><th width='15%' title='Tx Reduction the last 2h'>Wan Tx Reduction</th><th width='12%'>Graph</th></tr></thead><tbody>

END
;

for my $i (0 .. 64)
{
	print "<tr><td><center>" . $i . "</center></td><td>" . $sites{$i} . "</td><td><center><span id='ds_ready$i'>   </span></center></td><td><center><span id='bypass$i'>   </span></center></td><td title='Packet Loss Recovery and Packet Order Correction'><center><span id='plr_status$i'> </span></center></td>\n";
	if ( $sites{$i} ne '' )
	{
	print "<td width='80' title='Rx Reduction the last 2h'><div class='meter'><span style='width: 0%' id='meter_rx$i'><div style='position:relative; left:84px; font-size:9px; width:20px;' id='peer_rx_ratio$i'></div></span></div></td>\n";
	print "<td width='80' title='Tx Reduction the last 2h'><div class='meter'><span style='width: 0%' id='meter_tx$i'><div style='position:relative; left:84px; font-size:9px; width:20px;' id='peer_tx_ratio$i'></div></span></div></td>\n"; 
	print "<td><center><a href='freetraf.pl?main=peer$i'><img src='/images/zoom_in_14.png' height='12' width='12'/></a></center></td></tr>\n";
	}
	else { print "<td></td><td></td><td></td></tr>"; }
}



print <<END
</table></div>


</body>
</html>
END
;
