#!/usr/bin/perl
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI; 
my $cgi = CGI->new;
my $time = $cgi->param("time");
my $topn = $cgi->param("topn");
my $export = $cgi->param("export");
my $peervalue = $cgi->param("peervalue");

print "Content-type: text/html;\n\n";

open(ROW, "<" , "/tce/etc/wanos/peersites") || die("Couldn't open the file. Error: $!\n");
while (<ROW>)
{
        chomp;
        next if /^\s*\#/;
        next unless /=/;
        my ($key, $commastring) = split(/\s*=\s*/,$_,2);
        $commastring =~ s/(\$(\w+))/$rows{$2}/g;
        $rows{$key} = $commastring;
        my @values = split(',',$commastring);
        $sites{$values[1]} = $values[0];
}
close ROW;

my @portobjs;
open(OBJ, "<" , "/tce/etc/wanos/portobjects") || die("Couldn't open the file. Error: $!\n");
    while (<OBJ>)
    {
    chomp;
    my ($key, $commastring) = split(/,/,$_,2);
    $portobjs{$key} = $commastring;
    }
close OBJ;

my %ltable = ();
my %wtable = ();
my %lptable = ();
my %wptable = ();
my %wlegend = ();
my @lpercent;
my @wpercent;
my @lport;
my @wport;

if ($topn eq '') { $topn = 10; }
if ($time eq '') { $time = 1800; }
my $timename;
if ($time eq '300') { $timename = "Last 5 Min"; }
if ($time eq '900') { $timename = "Last 15 Min"; }
if ($time eq '1800') { $timename = "Last 30 Min"; }
if ($time eq '3600') { $timename = "Last 60 Min"; }
if ($time eq '7200') { $timename = "Last 2 Hours"; }
if ($time eq '28800') { $timename = "Last 8 Hours"; }
if ($time eq '86400') { $timename = "Last 24 Hours"; }

my $peername;
if ( $peervalue eq '' ) { $peername = "All"; }
else { $peername = "Peer " . $peervalue; }

if ( $export eq 'pdf' )
{
open (OUT, ">/tce/www/stats/reports/topprotocols.html") or die "Can't open OUT: $!";
$nav=1;
$batch=5000;
$url="/tce/www";
}
else { open (OUT, ">&STDOUT") or die "Can't open OUT: $!"; }

if ( $nav eq '') { system( "sudo -u tc /tce/etc/wanos/flows $time ports $peervalue" ); }
open(LROW, "<" , "/wanos/nf/l0/ports") || die("Couldn't open the file. Error: $!\n");
while (<LROW>)
{
	chomp;
	next unless /-/;
	my @array = split(',',$_);
	push(@lpercent, $array[10]);
        my $label = (split(',',($portobjs{"$array[4]/6"})))[1];
        if ($label eq '') { $label = "TCP " . $array[4]; }
	push(@lport, $label);
	$ltable{$array[4]} = $array[9];
	$lptable{$array[4]} = $array[10];
}
close LROW;

my $i=0;
open(WROW, "<" , "/wanos/nf/w0/ports") || die("Couldn't open the file. Error: $!\n");
while(<WROW>)
{
	chomp;
	next unless /-/;
	my @array2 = split(',',$_);
	push(@wpercent, $array2[10]);
        my $label = (split(',',($portobjs{"$array2[4]/6"})))[1];
        if ($label eq '') { $label = "TCP " . $array2[4]; }
	push(@wport, $label);
	$wtable{$array2[4]} = $array2[9];
	$wptable{$array2[4]} = $array2[10];
	$wlegend{$array2[4]} = $i++;
}
close WROW;

@legendb = ( "#C8E184", "#7D9DBD", "#F9D471", "#E68080", "#94D4AA", "#FABDAD", "#C0d0FF", "#ECBDEB", "#ADDEDE", "#D7D7D7", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe",);
@legendc = ( "#D3E79D", "#6EA8C5", "#FADD8D", "#E88D8D", "#A3DAB6", "#FBCABD", "#CFE2FF", "#F0CAEF", "#BDE5E5", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe", "#DeDeDe",);

print OUT  <<END
<!DOCTYPE html>
<html>
<head>
  <TITLE>Top Applications</TITLE>
  <style>
    body { font-family: Verdana,Tahoma,Arial,Helvetica; font-size:8pt; margin-left:30px;}
    .header1 { font-size: 8pt; font-weight: 900; color: 777777}
    .header2 { font-size: 8pt; font-weight: 900; color: 707070}
  </style>
<link rel="stylesheet" href="$url/css/base.css" type="text/css"/>
<link rel="stylesheet" href="$url/css/table.css" type="text/css"/>
<style>
	#box {
	width: 13px;
	height: 13px;
	}
      
	.headerSortDown:after { border-top-color:#777; left:-7px; top:-4px; }
	.headerSortUp:after { border-top-color:#777; left:-7px; top:-4px; }

	#canvas-holder{ width:30%; }

</style>

    <script src="$url/js/jquery.min.js"></script>
    <script src="$url/js/Chart.min.js"></script>
    <script>


	// Ports
	var LanData = [
END
;
	$i=0;
	foreach (@lpercent)
		{ print OUT  "{ value: " . $_ . ", color: '" . $legendb[$i] . "', highlight: '" . $legendc[$i] . "', label: '" . $lport[$i] . "' },\n";
		  $i++;
		  if ($i eq $topn) { last; }
		}
	print OUT  "];\n";
	print OUT  "var WanData = [\n";
	$i=0;
	foreach (@wpercent)
		{ print OUT  "{ value: " . $_ . ", color: '" . $legendb[$i] . "', highlight: '" . $legendc[$i] . "', label: '" . $wport[$i] . "' },\n";
		  $i++;
		  if ($i eq $topn) { last; }
		}
	print OUT  "];\n";


print OUT  <<END
    	window.onload = function(){
		var ctx = document.getElementById("chart-area").getContext("2d");
		window.myDoughnut = new Chart(ctx).Doughnut(LanData, {
			responsive : true,
END
;
if ( $export eq 'pdf' ) { print OUT "animation : false,\n"; }
print OUT <<END
			animationEasing : "easeOutExpo",
			animationSteps : 30,
			pointHitDetectionRadius : 6,
                        tooltipFontSize: 9,
                        tooltipYPadding: 2,
                        tooltipXPadding: 6,
                        tooltipCaretSize: 6,
                        tooltipFillColor: "rgba(0,0,0,0.4)",
			percentageInnerCutout : 65});

		var ctx = document.getElementById("chart-area2").getContext("2d");
                window.myDoughnut = new Chart(ctx).Doughnut(WanData, {
                        responsive : true,
END
;
if ( $export eq 'pdf' ) { print OUT "animation : false,\n"; }
print OUT <<END
                        animationEasing : "easeOutExpo",
                        animationSteps : 30,
                        pointHitDetectionRadius : 6,
                        tooltipFontSize: 9,
                        tooltipYPadding: 2,
                        tooltipXPadding: 6,
                        tooltipCaretSize: 6,
                        tooltipFillColor: "rgba(0,0,0,0.4)",
                        percentageInnerCutout : 65});


    };


    </script>
	<script type="text/javascript" src="/js/jquery.tablesorter.min.js"></script>
	<script type="text/javascript" id="js">

	\$.tablesorter.addParser({
	    id: 'thousands',
	    is: function(s) {
	        return false;
	    },
	    format: function(s) {
	return jQuery.tablesorter.formatFloat(s.replace(/,/g, ""));
	    },
	    type: 'numeric'
	});

	\$(function() {
	    \$("table").tablesorter({
	        sortInitialOrder: 'desc',
	        headers: {
	            0: { sorter:false },
	            3: { sorter:'thousands' },
	            5: { sorter:'thousands' },
	            8: { sorter:false }
	        }
	    });
	});

</script>

</head>
<body bgcolor="#FDFDFC" topMargin='5'>
<br><span class='header'>Protocol Distribution</span>
<br><br>
	<form action="protocols.pl" method="post">
<table class="nav-table" style="width:840px;">
<tr><th colspan="5">Protocols</th></tr>
<tr><td>
	Protocols:<br><select name="topn" >
	<option value="$topn">Top $topn</option>
	<option value="10">Top 10</option>
	<option value="20">Top 20</option>
	<option value="30">Top 30</option>
	<option value="40">Top 40</option>
	</select></td>
	<td>Period:<br> <select name="time" >
	<option value="$time">$timename</option>
	<option value="300">Last 5 Min</option>
	<option value="900">Last 15 Min</option>
	<option value="1800">Last 30 Min</option>
	<option value="3600">Last 60 Min</option>
	<option value="7200">Last 2 Hours</option>
	<option value="28800">Last 8 Hours</option>
	<option value="86400">Last 24 Hours</option>
	</select></td>
	<td>Peer:<br>                                      
	<select name="peervalue" title="Session Stats Level">
	<option value="$peervalue">$peername</option>
	<option value="">All</option>
	<option value="0">Peer 0</option>
	<option value="1">Peer 1</option>
	<option value="2">Peer 2</option>
	<option value="3">Peer 3</option>
	<option value="4">Peer 4</option>
	<option value="5">Peer 5</option>
	<option value="6">Peer 6</option>
	<option value="7">Peer 7</option>
	<option value="8">Peer 8</option>
	<option value="9">Peer 9</option>
	<option value="10">Peer 10</option>
	<option value="11">Peer 11</option>
	<option value="12">Peer 12</option>
	<option value="13">Peer 13</option>
	<option value="14">Peer 14</option>
	<option value="15">Peer 15</option>
	<option value="16">Peer 16</option>
	</select></td>
	<td>Export:<br><select name="export" >
	<option></option><option value="pdf">&nbsp;PDF&nbsp;</option>
	</select></td>
	<td align='left'><br><input type='submit' value='Go' style="font-size: 8pt">
</td></tr>
</table>
	</form>


<div style="float:left">
<fieldset style="width:410px; height:300px">
<legend>Top Ports : LAN</legend>
<center><div id="canvas-holder" style="width:220px; height:250px; margin-top:30px;">
<canvas id="chart-area" width="250" height="250"/>
</div></center>
</fieldset>
</div>

<div style="margin-left:430px">
	<fieldset style="width:410px; height:300px;">
	<legend>Top Ports : WAN</legend>
	<center>
		<div id="canvas-holder" style="width:220px; height:250px; margin-top:30px;">
		<canvas id="chart-area2" width="250" height="250"/>
		</div>
	</center>
	</fieldset>
</div>


<br />
<table style="width:840px;" class="striped sortable">
<thead><tr><th width='4%'></th><th width='13%'>Application</th><th width='8%'>% of LAN</th><th width='9%'>LAN MB</th><th width='18%'>Reduction</th><th width='10%'>WAN MB</th><th width='10%'>% of WAN</th><th width='4%'> </th></tr></thead><tbody>

END
;


$i=0;
foreach my $key ( sort { $lptable{$b} <=> $lptable{$a} } keys %lptable)
    {
	($knownport, $portdesc) = split(',',$portobjs{"$key/6"});
	if ($knownport eq '') { $knownport = $key;  $portdesc = "TCP Port: " .  $knownport; }	
	my $ldata = sprintf('%.1f',$ltable{$key}/1024000);
	$ldata =~ s/(\d)(?=(\d{3})+(\D|$))/$1\,/g;
	print OUT  "<tr><td title='TCP Port: " . $key . " - " . $knownport . "'><center><div id='box' style='background:" . $legendc[$i++] .  "'></div></center></td><td title='TCP Port: " . $key . " - " . $portdesc . "'>" . $knownport . "</td><td>" . $lptable{$key} . "</td><td title='Bytes : " . $ltable{$key} . "'>" . $ldata . "</td>\n";

        # $z = $y ? $x / $y : 0;                                                            
        my $scale = $ltable{$key} ? (($ltable{$key} - $wtable{$key})/$ltable{$key}) : 0;
        $scale = sprintf("%.1f", $scale * 100);
	#my $scale = sprintf("%.0f", (($ltable{$key} - $wtable{$key})/$ltable{$key}) * 100);
	if ($scale <= 0) { $scale = 0; }
	if ($wptable{$key} eq '') { $wptable{$key} = 0; }
	my $wdata = sprintf('%.1f',$wtable{$key}/1024000);
	$wdata =~ s/(\d)(?=(\d{3})+(\D|$))/$1\,/g;
	print OUT  "<td>" . "<div class='meter'><span style='width: " . $scale . "%'><div style='position:relative; left:84px; font-size:9px'>" . $scale . "%</div></span></div></td>\n";
	if ($wlegend{$key} eq '') { $wlegend{$key} = 19; }
	print OUT  "<td title='Bytes : " . $wtable{$key} . "'>" . $wdata . "</td><td>" .  $wptable{$key}  . "</td><td title='TCP Port: " . $key . " - " . $knownport . "'><center><div id='box' style='background:" . $legendc[$wlegend{$key}] .  "'></div></center></td></tr>\n";
	if ( $i eq $topn ) { last; }
     }




print OUT  <<END
</table>

</body>
</html>
END
;

close OUT;

if ( $export eq 'pdf' )
{
 system("/tce/packages/click/exporttool /tce/www/stats/reports/topprotocols.html /tce/www/stats/reports/topprotocols.pdf" );
 print <<END
	<html>
	<head><link rel="stylesheet" href="/css/base.css" type="text/css"/></head>
	<body bgcolor="#FDFDFC" topMargin='5'>
	<br><span class='header'>Protocol Distribution</span>
	<br><br>
	<table class="nav-table" style="width:840px;">
	<tr><th>Report Ready</th></tr><center><br><tr><td>
	Protocol report is ready for download:
	<a href='../stats/reports/topprotocols.pdf' target="_blank" style='color:#777'>Top $topn Protocols from the $timename</a></td></tr></table><br>
	</body></html>
END
;
}

