#!/usr/bin/perl
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;
use warnings;

print "Content-type: text/html;\n\n";

my @graphs;
my $cgi = CGI->new;
my $name = $cgi->param("trend");
my $desc = $cgi->param("desc");
my $time = $cgi->param("time");
my $export = $cgi->param("export");
if ($time eq '') { $time = 'Day'; }
my $timename;
if ($time eq 'Hour') { $timename = "Last Hour"; }
if ($time eq 'Day') { $timename = "Last Day"; }
if ($time eq 'Week') { $timename = "Last Week"; }
if ($time eq 'Month') { $timename = "Last Month"; }
if ($time eq 'Year') { $timename = "Last Year"; }
my $maingraph = $cgi->param("main");
if ($maingraph eq '') { $maingraph = 'All'; }
my $maingraphvalue = lc $maingraph;
$maingraphvalue=~ s/\s//g;
if  ($maingraph eq 'All')
{
	foreach my $i (0 .. 17)
	{
	    my $filename = "../stats/qosclass$i-tx-$time.png";
            if (-r $filename)
	    { push (@graphs, "qosclass$i,QoS Class $i : WAN Tx"); }
	}
}
else { push (@graphs, "$maingraphvalue,$maingraph : WAN Tx"); }

if ( $export eq 'pdf' )
{
open (OUT, ">/tce/www/stats/reports/qosclasses.html") or die "Can't open OUT: $!";
$url="/tce/www";
}
else { open (OUT, ">&STDOUT") or die "Can't open OUT: $!"; }

print OUT <<END
<!DOCTYPE html>
<html>
<head>
  <TITLE>QoS Class Graphs</TITLE>
  <META HTTP-EQUIV="Refresh" CONTENT="300">
  <META HTTP-EQUIV="Cache-Control" content="no-cache">
  <META HTTP-EQUIV="Pragma" CONTENT="no-cache">
  <style>
    body { font-family: Verdana,Tahoma,Arial,Helvetica; font-size:8pt; margin-left:30px;}
    .header { font-size: 8pt; font-weight: 900; color: 777777 }
  </style>
<link rel="stylesheet" href="$url/css/base.css" type="text/css"/>
</head>
<body bgcolor="#FDFDFC" topMargin='5'>

<br><span class='header'>Quality of Service Classes</span>
<br><br>
<form action="qosclasses.pl" method="post">

<table class='nav-table' style="width:840px;">
<tr><th colspan="4">Display</th></tr>
<tr>

	<td>Graph:<br><select name="main" onchange="this.form.submit()">
	<option value="$maingraph">$maingraph</option>
	<option value="Qos Class 0">QoS Class 0</option>
	<option value="Qos Class 1">QoS Class 1</option>
	<option value="Qos Class 2">QoS Class 2</option>
	<option value="Qos Class 3">QoS Class 3</option>
	<option value="Qos Class 4">QoS Class 4</option>
	<option value="Qos Class 5">QoS Class 5</option>
	<option value="Qos Class 6">QoS Class 6</option>
	<option value="Qos Class 7">QoS Class 7</option>
	<option value="Qos Class 8">QoS Class 8</option>
	<option value="Qos Class 9">QoS Class 9</option>
	<option value="Qos Class 10">QoS Class 10</option>
	<option value="Qos Class 11">QoS Class 11</option>
	<option value="Qos Class 12">QoS Class 12</option>
	<option value="Qos Class 13">QoS Class 13</option>
	<option value="Qos Class 14">QoS Class 14</option>
	<option value="Qos Class 15">QoS Class 15</option>
	<option value="Qos Class 16">QoS Class 16</option>
	<option value="Qos Class 17">QoS Class 17</option>
	<option value="All">All</option>
	</select></td>
	<td>Period:<br> <select name="time" >
	<option value="$time">$timename</option>
	<option value="Hour">Last Hour</option>
	<option value="Day">Last Day</option>
	<option value="Week">Last Week</option>
	<option value="Month">Last Month</option>
	<option value="Year">Last Year</option>
	</select></td>
	<td>Export:<br><select name="export" >
	<option></option><option value="pdf">&nbsp;PDF&nbsp;</option>
	</select></td>
	<td align='left'><br><input type='submit' value='Go' </td>
</tr>

</table>
</form>
END
;

	print OUT "<br>";
if ($name eq '')
{
	foreach $graph (@graphs)
	{
	    ($graphname, $desc) = split(',', $graph);
	    print OUT "<table class='graph-table' style='width:840px'><tr><th>$desc</th></tr><tr><td><div style='margin-left:90px'>";
	    my $filename = "../stats/$graphname-tx-$time.png";
	    if (-r $filename)
	    { print OUT "<a href='?trend=$graphname&desc=$desc'><img src='$url/stats/$graphname-tx-$time.png' border='0'><br></a></div></td></tr></table><br>"; }
	    else
	    { print OUT "No Data<br></div></td></tr></table><br>\n"; }
	}
}
else
{
	foreach $period ("Hour", "Day", "Week", "Month", "Year")
	{
	print OUT "<table class='graph-table' style='width:840px'><tr><th>$desc : $period</th></tr><tr><td><div style='margin-left:90px'><img src='$url/stats/$name-tx-$period.png' border='0'><br></div></td></tr></table><br>\n";
	}
}

print OUT <<END
<br><br>
</body>
</html>
END
;

close OUT;

if ( $export eq 'pdf' )
{
 system("/tce/packages/click/exporttool /tce/www/stats/reports/qosclasses.html /tce/www/stats/reports/qosclasses.pdf" );
 print <<END
        <html>
        <head><link rel="stylesheet" href="/css/base.css" type="text/css"/></head>
        <body bgcolor="#FDFDFC" topMargin='5'>
        <br><span class='header'>Optimization Report</span>
        <br><br>
        <table class="nav-table" style="width:840px;">
        <tr><th>Report Ready</th></tr><center><br><tr><td>
        QoS report is ready for download:
        <a href='../stats/reports/qosclasses.pdf' style='color:#777'>QoS stats for $maingraph from the $timename</a></td></tr></table><br></center>
        </body></html>
END
;
}

