#!/usr/bin/perl
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#
 
use CGI;
use warnings;
use autodie;
use Cwd qw(abs_path);

print "Content-type: text/html;\n\n" . "<!DOCTYPE html>\n<html>\n<head>\n";

my $cgi = CGI->new;
my $page = $cgi->param("page");
my $time = $cgi->param("time");
my $flowid = $cgi->param("flowid");
my $update=0;
if ($page eq '') { $page = 1; }
if ($time ne '') { $update = 1; }

open(LROW, "<" , "/wanos/nf/l0/flowdetail") || die("Couldn't open the file. Error: $!\n");
chomp(my @lrows = <LROW>);
close LROW;
open(WROW, "<" , "/wanos/nf/w0/flowdetail") || die("Couldn't open the file. Error: $!\n");
chomp(my @wrows = <WROW>);
close WROW;
my @portobjs;
open(OBJ, "<" , "/tce/etc/wanos/portobjects") || die("Couldn't open the file. Error: $!\n");
    while (<OBJ>)
    {
    chomp;
    my ($key, $commastring) = split(/,/,$_,2);
    $portobjs{$key} = $commastring;
    }
close OBJ;


my $lrownum = scalar @lrows;
my $wrownum = scalar @wrows;
my $rows = ();
my %table = ();
my %sorted = ();
my %portinfo = ();

for (my $i = 1; $i < ($lrownum - 4); $i++)
    {
     @lvalues = split(' ',$lrows[$i]);
     $table{($lvalues[0].$lvalues[1].$lvalues[2].$lvalues[3])} = $lvalues[4];
     }

for (my $i = 1; $i < ($wrownum - 4); $i++)
    {
     my @wvalues = split(' ',$wrows[$i]);
     my $id1 = ($wvalues[0].$wvalues[2]);
     my $id2 = ($wvalues[2].$wvalues[0]);
     if (( "$flowid" eq "$id1" ) || ( "$flowid" eq "$id2" ))
     {
	my $ldata = $table{($wvalues[0].$wvalues[1].$wvalues[2].$wvalues[3])};
	if ($ldata > 1000)
	{
	    my $scale = (100 - (sprintf("%.0f", ($wvalues[4] / $ldata) * 100)));
	    if ($scale < 0) { $scale = 0; }
	    $ldata = sprintf("%.0f", ($ldata/1024));
	    $ldata =~ s/(\d)(?=(\d{3})+(\D|$))/$1\,/g;
	    $wdata = sprintf("%.0f", ($wvalues[4]/1024));
	    $wdata =~ s/(\d)(?=(\d{3})+(\D|$))/$1\,/g;
	    my $port = '';
	    if ( $wvalues[1] <= $wvalues[3] ) { $port = $portobjs{"$wvalues[1]/$wvalues[5]"}; }
	    if ( $port eq '' ) { $port =  $portobjs{"$wvalues[3]/$wvalues[5]"}; }
	    if ( $wvalues[5] eq "6" ) { $wvalues[5] = "tcp"; }
            else { $wvalues[5] = "udp"; }
	    $wvalues[7] = substr($wvalues[7], 0,  -4);
	    $rows{($wvalues[0].$wvalues[1].$wvalues[2].$wvalues[3])} = "$wvalues[0] $wvalues[1] $wvalues[2] $wvalues[3] $ldata $wdata $wvalues[5] $wvalues[6] $wvalues[7]";
	    $sorted{($wvalues[0].$wvalues[1].$wvalues[2].$wvalues[3])} = $scale;
	    $portinfo{($wvalues[0].$wvalues[1].$wvalues[2].$wvalues[3])} = "$port";
	 }
       }
     }
my @keys = sort { $sorted{$a} <=> $sorted{$b} } keys(%sorted);
my $rownum = scalar @keys;
my $batch = 86;
my $lastpage = sprintf("%.0f", ($rownum / $batch)+0.5);
my $nextpage = $page + 1;
my $prevpage = $page - 1;
if ($prevpage < 1 ) { $prevpage = 1; }
if ($nextpage > $lastpage ) { $nextpage = $lastpage; }



print <<END
<script type="text/javascript" src="/js/jquery.min.js"></script>
<script type="text/javascript" src="/js/jquery.tablesorter.min.js"></script>
<script type="text/javascript" id="js">

\$.tablesorter.addParser({ 
    id: 'thousands',
    is: function(s) { 
        return false; 
    }, 
    format: function(s) {
return jQuery.tablesorter.formatFloat(s.replace(/,/g, ""));
    }, 
    type: 'numeric' 
}); 

\$(function() {
    \$("table").tablesorter({
	sortInitialOrder: 'desc',
        headers: {
            0: { sorter:false },
            3: { sorter:'thousands' },
            4: { sorter:'thousands' }
        }
    });
});

</script>

  <link rel="stylesheet" href="/css/table.css" type="text/css"/>
  <link rel="stylesheet" href="/css/base.css" type="text/css"/>
</head>
<body bgcolor="#FDFDFC" topMargin='5' onload="window.parent.parent.scrollTo(0,0);">

<br><span class='header'>Session Detail</span>
<br><br>
END
;

   if ($update != 1)
   {
	print <<END
	<br><div style='width:840px;' >
	<table class="striped tight sortable">
	<thead><tr><th width='17%'>Source</th><th width='17%'>Destination</th><th width='15%'>LAN / WAN KB</th><th width='8%'>Proto</th><th width='12%'>Port</th><th width='16%'>Time</th><th width='18%'>Reduction</th></tr></thead><tbody>
END
;
	my $c = -1;
	foreach (reverse @keys)
    {
	$c++;
	next if $c < (($page * $batch) - $batch);
	if ($c == ($page * $batch)) { last; }
	my $ratio = $sorted{$_};	
	my @values = split(' ',$rows{$_});
	my @valuesc = split(/,/,$portinfo{$_});
	print "<tr><td>" . $values[0] . ":" .  $values[1] . "</td>\n";	
	print "<td>" . $values[2] . ":" .  $values[3] . "</td>\n";	
	print "<td><center>" . $values[4] . " / ". $values[5] . "</center></td>\n";
	print "<td><center>" . $values[6] . "</center></td>\n";
	print "<td title='" . $valuesc[1] . "'><center>" . $valuesc[0] . "</center></td>\n";
	print "<td>" . $values[7] . " " . $values[8] . "</td>\n";
	print "<td><div class='meter'><span style='width: " . $ratio . "%'><div style='position:relative; left:84px; font-size:9px'>" . $ratio . "%</div></span></div></td></tr>\n";
    }


	print <<END
	</tbody></table></div>
	<ul class="navibar pag1" style="position: relative; left: 280px;">
	<li><a href="?page=1&flowid=$flowid">&nbsp;&nbsp;&#9668;&#8214;&nbsp;&nbsp;</a></li>
	<li><a href="?page=$prevpage&flowid=$flowid">&nbsp;&nbsp;&#9668;&nbsp;&nbsp;</a></li>
	<li><a href="">&nbsp;&nbsp; $page &nbsp;&nbsp;</a></li>
	<li><a href="?page=$nextpage&flowid=$flowid">&nbsp;&nbsp;&#9658;&nbsp;&nbsp;</a></li>
	<li><a href="?page=$lastpage&flowid=$flowid">&nbsp;&nbsp;&#8214;&#9658;&nbsp;&nbsp;</a></li></ul>
	</ul><br>

END
;
  }

print "<br></body></html>";

if ($update == 1)
{
#open(CMD, "|sudo -u tc /tce/etc/wanos/flows &");
}

