#!/usr/bin/perl
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#
 
use CGI;
#use warnings;
use autodie;
use Cwd qw(abs_path);

print "Content-type: text/html;\n\n";

my $cgi = CGI->new;
my $page = $cgi->param("page");
my $time = $cgi->param("time");
my $maxkb = $cgi->param("maxkb");
my $minkb = $cgi->param("minkb");
my $ipfilter = $cgi->param("ip");
my $portfilter = $cgi->param("port");
my $peervalue = $cgi->param("peervalue");
my $export = $cgi->param("export");
my $batch = $cgi->param("batch");
my $nav = $cgi->param("nav");
my $url = $cgi->param("url");
my $displayip;
my $displayport;
my $displayminkb = $minkb;
my $displaymaxkb = $maxkb;
if ($page eq '') { $page = 1; }
if ($minkb eq '') { $minkb = 10000; $displayminkb = 10; }
else { $displayminkb = $minkb; $minkb *= 1000; }
if ($minkb eq '0') { $minkb = 1000; $displayminkb = 1; }
if ($maxkb eq '') { $maxkb = 100000000000; $displaymaxkb = ''; }
else { $displaymaxkb = $maxkb; $maxkb *= 1000; }
if ($displaymaxkb = 100000000000) { $displaymaxkb = ''; }
if ($batch eq '') { $batch = 110; }
if ($ipfilter eq '') { $ipfilter = ".*"; $displayip = ''; }
else { $displayip = $ipfilter;}
if ($portfilter eq '') { $portfilter = ".*"; $displayport = '';}
else { $displayport = $portfilter; }
if ($time eq '') { $time = 1800; }
my $timename;
if ($time eq '300') { $timename = "Last 5 Min"; }
if ($time eq '900') { $timename = "Last 15 Min"; }
if ($time eq '1800') { $timename = "Last 30 Min"; }
if ($time eq '3600') { $timename = "Last 60 Min"; }
if ($time eq '7200') { $timename = "Last 2 Hours"; }
if ($time eq '28800') { $timename = "Last 8 Hours"; }
if ($time eq '86400') { $timename = "Last 24 Hours"; }

if ( $export eq 'pdf' )
{
open (OUT, ">/tce/www/stats/reports/sessions.html") or die "Can't open OUT: $!";
$nav=1;
$batch=1000;
$url="/tce/www";
}
else { open (OUT, ">&STDOUT") or die "Can't open OUT: $!"; }

if ( $nav eq '' ) { system( "sudo -u tc /tce/etc/wanos/flows $time flows $peervalue" ); } 

open(LROW, "<" , "/wanos/nf/l0/flowdetail") || die("Couldn't open the file. Error: $!\n");
chomp(my @lrows = <LROW>);
close LROW;
open(WROW, "<" , "/wanos/nf/w0/flowdetail") || die("Couldn't open the file. Error: $!\n");
chomp(my @wrows = <WROW>);
close WROW;
my @portobjs;
open(OBJ, "<" , "/tce/etc/wanos/portobjects") || die("Couldn't open the file. Error: $!\n");
    while (<OBJ>)
    {
    chomp;
    my ($key, $commastring) = split(/,/,$_,2);
    $portobjs{$key} = $commastring;
    }
close OBJ;


my $lrownum = scalar @lrows;
my $wrownum = scalar @wrows;
my $rows = ();
my %table = ();
my %sorted = ();
my %portinfo = ();

for (my $i = 1; $i < ($lrownum - 4); $i++)
    {
     @lvalues = split(' ',$lrows[$i]);
	if 	(($lvalues[4] > $minkb) &&
		(($lvalues[0] =~ /^$ipfilter$/) || ($lvalues[2] =~ /^$ipfilter$/)) &&
		(($lvalues[1] =~ /^$portfilter/) || ($lvalues[3] =~ /^$portfilter/)) &&
		($lvalues[4] < $maxkb))
	{
		$table{($lvalues[0].$lvalues[1].$lvalues[2].$lvalues[3])} = $lvalues[4];
	}
     }

for (my $i = 1; $i < ($wrownum - 4); $i++)
    {
     my @wvalues = split(' ',$wrows[$i]);
     my $ldata = $table{($wvalues[0].$wvalues[1].$wvalues[2].$wvalues[3])};
     if ($ldata > ($minkb))
	{
	my $scale = (100 - (sprintf("%.0f", ($wvalues[4] / $ldata) * 100)));
	if ($scale < 0) { $scale = 0; }
	$ldata = sprintf("%.0f", ($ldata/1024));
	$ldata =~ s/(\d)(?=(\d{3})+(\D|$))/$1\,/g;
	$wdata = sprintf("%.0f", ($wvalues[4]/1024));
	$wdata =~ s/(\d)(?=(\d{3})+(\D|$))/$1\,/g;
	my $port = '';
	if ( $wvalues[1] <= $wvalues[3] ) { $port = $portobjs{"$wvalues[1]/$wvalues[5]"}; }
	if ( $port eq '' ) { $port =  $portobjs{"$wvalues[3]/$wvalues[5]"}; }
	if ( $port eq '' ) { $port =  $portobjs{"$wvalues[1]/$wvalues[5]"}; }
	$rows{($wvalues[0].$wvalues[1].$wvalues[2].$wvalues[3])} = "$wvalues[0] $wvalues[1] $wvalues[2] $wvalues[3] $ldata $wdata";
	$sorted{($wvalues[0].$wvalues[1].$wvalues[2].$wvalues[3])} = $scale;
	$portinfo{($wvalues[0].$wvalues[1].$wvalues[2].$wvalues[3])} = "$port";
	}
     }
my @keys = sort { $sorted{$a} <=> $sorted{$b} } keys(%sorted);
my $rownum = scalar @keys;
my $lastpage = sprintf("%.0f", ($rownum / $batch)+0.5);
my $nextpage = $page + 1;
my $prevpage = $page - 1;
if ($prevpage < 1 ) { $prevpage = 1; }
if ($nextpage > $lastpage ) { $nextpage = $lastpage; }


print OUT "<!DOCTYPE html>\n<html>\n<head>\n";

print OUT <<END
<script type="text/javascript" src="/js/jquery.min.js"></script>
<script type="text/javascript" src="/js/jquery.tablesorter.min.js"></script>
<script type="text/javascript" id="js">

\$.tablesorter.addParser({ 
    id: 'thousands',
    is: function(s) { 
        return false; 
    }, 
    format: function(s) {
return jQuery.tablesorter.formatFloat(s.replace(/,/g, ""));
    }, 
    type: 'numeric' 
}); 

\$(function() {
    \$("table").tablesorter({
	sortInitialOrder: 'desc',
        headers: {
            0: { sorter:false },
            3: { sorter:'thousands' },
            4: { sorter:'thousands' },
            7: { sorter:false }
        }
    });
});

</script>

<!--  <link rel="stylesheet" href="$url/css/table.css" type="text/css"/> -->
  <link rel="stylesheet" href="$url/css/base.css" type="text/css"/>
<style>                
        .headerSortDown:after { border-top-color:#777; left:-7px; top:-4px; }
        .headerSortUp:after { border-top-color:#777; left:-7px; top:-4px; }
</style> 
</head>
<body bgcolor="#FDFDFC" topMargin='5' onload="window.parent.parent.scrollTo(0,0);">

<br><span class='header'>Flow Sessions</span>
<br><br>
<form action="sessionsummary.pl" method="post">
<table class="nav-table" style='width:840px'>
<tr><th colspan='7'>Display Options</th></tr>
<tr>
<td>Address:<br><input title='Full or partial IP Address as regular expression.&#013;Example: 172.16.100.* will match 172.16.100.0/24' name="ip" type="text" size="12" style="font-size: 8pt; width:84px" value='$displayip'></td>
<td>Port:<br><input title='Port number'  name="port" type="text" size="6" style="font-size: 8pt; width:70px" value='$displayport'></td>
<td>Min KB:<br><input title='Minimum data'  name="minkb" type="text" size="6" style="font-size: 8pt; width:70px" value='$displayminkb'></td>
<td>Peer:<br>
<select name="peervalue" style="font-size: 8pt; width:70px" title="Session Stats Level">
<option value="$peervalue">$peervalue</option>
<option value="">All</option>
<option value="0">Peer 0</option>
<option value="1">Peer 1</option>
<option value="2">Peer 2</option>
<option value="3">Peer 3</option>
<option value="4">Peer 4</option>
<option value="5">Peer 5</option>
<option value="6">Peer 6</option>
<option value="7">Peer 7</option>
<option value="8">Peer 8</option>
<option value="9">Peer 9</option>
<option value="10">Peer 10</option>
<option value="11">Peer 11</option>
<option value="12">Peer 12</option>
<option value="13">Peer 13</option>
<option value="14">Peer 14</option>
<option value="15">Peer 15</option>
<option value="16">Peer 16</option>
</select></td>
<td>Period:<br><select name="time" style="font-size: 8pt; width:70px">
<option value="$time">$timename</option>
<option value="300">Last 5 Min</option>
<option value="900">Last 15 Min</option>
<option value="1800">Last 30 Min</option>
<option value="3600">Last 60 Min</option>
<option value="7200">Last 2 Hours</option>
<option value="28800">Last 8 Hours</option>
<option value="86400">Last 24 Hours</option>
</select></td>
<td>Export:<br><select name="export" style="font-size: 8pt; width:70px">
<option></option><option value="pdf">&nbsp;PDF&nbsp;</option>
</select></td>
<td><br><input type='submit' value='Go' style="font-size: 8pt"></td>
</tr></table></center></form>
<br>
END
;

   if ($update != 1)
   {
	print OUT <<END
	<table class="striped tight sortable" style='width:840px;' title='Session Summary for the $timename'>
	<thead><tr><th width='2%'>#</th><th width='20%'>Source</th><th width='20%'>Destination</th><th width='12%'>LAN KB</th><th width='12%'>WAN KB</th><th width='14%'>Application</th><th width='16%'>Reduction</th><th width='2%'>Detail</th></tr></thead><tbody>
END
;
	my $c = -1;
	foreach (reverse @keys)
    {
	$c++;
	next if $c < (($page * $batch) - $batch);
	if ($c == ($page * $batch)) { last; }
	my $ratio = $sorted{$_};	
	my @values = split(' ',$rows{$_});
	my @valuesc = split(/,/,$portinfo{$_});
	#next if $values[1]
	print OUT "<tr><td>" . ($c+1) . "</td>";
	print OUT "<td>" . $values[0] . ":" .  $values[1] . "</td>\n";	
	print OUT "<td>" . $values[2] . ":" .  $values[3] . "</td>\n";	
	print OUT "<td>" . $values[4] . "</td>\n";
	print OUT "<td>" . $values[5] . "</td>\n";
	print OUT "<td title='" . $valuesc[1] . "'>" . $valuesc[0] . "</td>\n";
	print OUT "<td width='130'><div class='meter'><span style='width: " . $ratio . "%'><div style='position:relative; left:84px; font-size:9px; width:20px'>" . $ratio . "%</div></span></div></td>\n";
	print OUT "<td><center><a href='sessiondetail.pl?flowid=" . $values[0] . $values[2];
	print OUT "' title='Session details'><img src='$url/images/zoom_in_14.png' height='12' width='12'/></a></center></td></tr>\n";
    }


	print OUT <<END
	</tbody></table>
	<ul class="navibar pag1" style="position: relative; left: 280px;">
	<li><a href="?page=1&ip=$displayip&port=$displayport&minkb=$displayminkb&maxkb=$displaymaxkb&time=$time&nav=1">&nbsp;&nbsp;&#9668;&#8214;&nbsp;&nbsp;</a></li>
	<li><a href="?page=$prevpage&ip=$displayip&port=$displayport&minkb=$displayminkb&maxkb=$displaymaxkb&time=$time&nav=1">&nbsp;&nbsp;&#9668;&nbsp;&nbsp;</a></li>
	<li><a href="">&nbsp;&nbsp; $page &nbsp;&nbsp;</a></li>
	<li><a href="?page=$nextpage&ip=$displayip&port=$displayport&minkb=$displayminkb&maxkb=$displaymaxkb&time=$time&nav=1">&nbsp;&nbsp;&#9658;&nbsp;&nbsp;</a></li>
	<li><a href="?page=$lastpage&ip=$displayip&port=$displayport&minkb=$displayminkb&maxkb=$displaymaxkb&time=$time&nav=1">&nbsp;&nbsp;&#8214;&#9658;&nbsp;&nbsp;</a></li></ul>
	</ul><br>

END
;
  }

print OUT "<br></body></html>";

close OUT;

if ( $export eq 'pdf' )
{
 system("/tce/packages/click/exporttool /tce/www/stats/reports/sessions.html /tce/www/stats/reports/sessionsreport.pdf" );
 print <<END
        <html>
        <head><link rel="stylesheet" href="/css/base.css" type="text/css"/></head>
        <body bgcolor="#FDFDFC" topMargin='5'>
        <br><span class='header'>Flow Sessions</span>
        <br><br>
        <table class="nav-table" style="width:840px;">
        <tr><th>Report Ready</th></tr><center><br><tr><td>
        Flow Session report is ready for download (Max 1000 records): 
        <a href='../stats/reports/sessionsreport.pdf' style='color:#777'> Sessions from the $timename</a></td></tr></table><br></center>
        </body></html>
END
;
}

