#!/usr/bin/perl
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#
 
use CGI;
use warnings;
use autodie;
use Cwd qw(abs_path);

my $cgi = CGI->new;
my $hostname = $cgi->param("host");
my $mode = $cgi->param("mode");
my $sim = $cgi->param("sim");
my $update=0;
my $reconfigure=0;
my $errmsg='';
my @config;
my $ip = $cgi->param("ip");
my $mask = $cgi->param("mask");
my $gw = $cgi->param("gw");
my $virt_lan0 = $cgi->param("virt_lan0");
my $deployment = $cgi->param("deployment");
my $mtu = $cgi->param("mtu");
my $hold = $cgi->param("hold");
my $nfexpire = $cgi->param("nfexpire");
my $nfexport = $cgi->param("nfexport");
my $nfpeerip = $cgi->param("nfpeerip");
my $nfpeerport = $cgi->param("nfpeerport");
my $dns1 = $cgi->param("dns1");
my $comp_lvl = $cgi->param("comp_lvl");
my $dd_lvl = $cgi->param("dd_lvl");
my $rsp_lvl = $cgi->param("rsp_lvl");
my $net;

my $encapproto = $cgi->param("encapproto");
my $newencapproto = 0;
my $new_deployment = 0;
my $new_virt_lan = 0;

my $time;
my $time_day = $cgi->param("day");
my $time_month = $cgi->param("month");
my $time_year = $cgi->param("year");
my $time_hour = $cgi->param("hour");
my $time_minute = $cgi->param("minute");

my $sshd = $cgi->param("sshd");
my $dstore = $cgi->param("dstore");

### Drive the DS is mounted on
my $link = '/wanos';
my $path = abs_path($link);
my @drive  = split '/', $path;

my %peerips = ();
open(ROW, "<" , "/tce/etc/wanos/peersites") || die("Couldn't open the file. Error: $!\n");
while (<ROW>)
{
        chomp;
        next if /^\s*\#/;
        next unless /=/;
        my ($key, $commastring) = split(/\s*=\s*/,$_,2);
        $commastring =~ s/(\$(\w+))/$rows{$2}/g;
        $rows{$key} = $commastring;
        my @values = split(',',$commastring);
        $sites{$values[1]} = $values[0];
	if ($peerips{$values[1]} eq '') { $peerips{$values[1]} = $values[3]; }
}
close ROW;


open(CONFIG, "<" , "/tce/etc/wanos/wanos.conf") || die("Couldn't open the file. Error: $!\n");
    while (<CONFIG>)
    {
    chomp;
    next if /^\s*\#/;
    next unless /=/;
    my ($key, $variable) = split(/\s*=\s*/,$_,2);
    $variable =~ s/(\$(\w+))/$config{$2}/g;
        $config{$key} = $variable;
    }
close CONFIG;

if ($dstore eq "") { $dstore = $config{DSTORE};}
if ($sshd eq "") { $sshd = $config{SSHD};}
if ($mtu eq "") { $mtu = $config{MTU};}
if ($dns1 eq "") { $dns1 = $config{DNS_SERVER_1};}
if ($hold eq "") { $hold = $config{HOLD};}
if ($hold > 86400) { $hold = 86400;}
if ($nfexpire eq "") { $nfexpire = $config{NFEXPIRE};}
if ($nfexport eq "") { $nfexport = $config{NFEXPORT};}
if ($nfpeerip eq "") { $nfpeerip = $config{NFPEERIP};}
if ($nfpeerport eq "") { $nfpeerport = $config{NFPEERPORT};}
#if ($ip eq "") { $ip = $config{IP}; $mask = $config{MASK};}
if ($gw eq "") { $gw = $config{GW};}
#if ($mask eq "") { $mask = $config{MASK};}
if ($mode eq "") { $mode = $config{MODE};}
if ($deployment eq "") { $deployment = $config{DEPLOYMENT_MODE};}
if ($virt_lan0 eq "") { $virt_lan0 = $config{VIRT_LAN0};}
if ($hostname eq "") { $hostname = $config{HOST};}
if ($sim eq "") { $sim = $config{SIM};}
if ($encapproto eq "") { $encapproto = $config{ENCAPPROTO};}
if ($comp_lvl eq "") { $comp_lvl = $config{COMPALGO};}
if ($dd_lvl eq "") { $dd_lvl = $config{DD_LEVEL};}
if ($rsp_lvl eq "") { $rsp_lvl = $config{RSP_LEVEL};}

if ($ip eq "")
 {
  $ip = $config{IP}; $mask = $config{MASK};
 }
else
 {
  $ip =~ s/\s//g;
  ($ip,$mask) = split ("/",$ip);
 }

if ($virt_lan0 eq "")
 {
  $virt_lan0 = $config{VIRT_LAN0};
 }
else
 {
  $virt_lan0 =~ s/\s//g;
  ($virt_lan_ip,$virt_lan_mask) = split ("/",$virt_lan0);
 }


if (	($mode ne $config{MODE}) || 
	($sim ne $config{SIM}) || 
	($mtu ne $config{MTU}) || 
	($hold ne $config{HOLD})  || 
	($ip ne $config{IP}) || 
	($gw ne $config{GW}) || 
	($mask ne $config{MASK}) || 
	($comp_lvl ne $config{COMPALGO}) || 
	($dd_lvl ne $config{DD_LEVEL}) || 
	($rsp_lvl ne $config{RSP_LEVEL})
   )
{
  $update=1; 
  $reconfigure=1;
}

if ($virt_lan0 ne $config{VIRT_LAN0})
{
  $new_virt_lan=1;
  $reconfigure=1;
}

if($encapproto ne $config{ENCAPPROTO})
{
  $newencapproto=1; 
  $reconfigure=1;
}

if ($deployment ne $config{DEPLOYMENT_MODE}) 
{
  $new_deployment=1;
  $reconfigure=1;
}


my $sshupdate = 0;
if ($sshd ne $config{SSHD})
{
  $update=1;
  $sshupdate=1;
}

my $reboot = 0;
if (( $dstore ne $config{DSTORE} ) && ( $dstore ne $drive[2] ))
{
  $update=1;
  $reboot=1;
}

if (($time_day ne "") && ($time_month ne "") && ($time_year ne "") && ($time_hour ne "") && ($time_minute ne ""))
{
  $time_year = "20" . $time_year;
  $time = 1;
  $reconfigure=1;
}

if ( ($hostname ne $config{HOST}) || ($nfpeerip ne $config{NFPEERIP}) || ($nfpeerport ne $config{NFPEERPORT}) || ($nfexpire ne $config{NFEXPIRE}) || ($nfexport ne $config{NFEXPORT}) )
{                                
  $update=1; 
}

if ($dns1 ne $config{DNS_SERVER_1})
{
  $dnsupdate=1;
  my $ipno = qr/2(?:5[0-5]|[0-4]\d)|1\d\d|[1-9]?\d/x;
  if (( $dns1 ne "") && ( $dns1 !~ /^($ipno\.){3}$ipno$/ )) {  $dnsupdate = 0; $errmsg = "DNS Server IP Address invalid: $dns1"; }
}


if ( $update == 1 )
 {
  if ($mask < 8 || $mask > 32) { $reconfigure=0; $update = 0; $errmsg = "MASK invalid: $mask";}
 }


my $ipno = qr/2(?:5[0-5]|[0-4]\d)|1\d\d|[1-9]?\d/x;
if ( $update == 1 )
{
  if ( $ip =~ /^($ipno\.){3}$ipno$/ )
  {
	$update=1;
	$longmask="255";
	$b=$mask-8;
	for($i=0;$i<3;$i++)
  	{
	  $b=$b-8;
	  if($b >= 0) { $longmask = $longmask . "." . 255;}
	  if($b < 0)
      	   {   
 		if ($b == -1)  { $longmask = $longmask . "." . 254;}
 		if ($b == -2)  { $longmask = $longmask . "." . 252;}
 		if ($b == -3)  { $longmask = $longmask . "." . 248;}
 		if ($b == -4)  { $longmask = $longmask . "." . 240;}
 		if ($b == -5)  { $longmask = $longmask . "." . 224;}
 		if ($b == -6)  { $longmask = $longmask . "." . 192;}
 		if ($b == -7)  { $longmask = $longmask . "." . 128;}
 		if ($b <= -8)  { $longmask = $longmask . "." . 0;}
          }
  	}

	@maskbyte=split /\./,$longmask;
	@ipbyte=split /\./, $ip;
	for($i=0;$i<4;$i++)
	{
	   $b1=$maskbyte[$i]+0;
	   $b2=$ipbyte[$i]+0;
	   $NetByte=$b1&$b2;
	    if($i != 0)	{$NetAddr = $NetAddr . "." . $NetByte; }
	    else 	{ $NetAddr=$NetByte ;}
    
	}
  }
  else {  $reconfigure=0; $update = 0; $errmsg = "IP/MASK invalid: $ip/$mask";}


  if ( $gw =~ /^($ipno\.){3}$ipno$/ )
  { 
         @gwbyte=split /\./, $gw;
         for($i=0;$i<4;$i++)
         {
            $b1=$maskbyte[$i]+0;
            $b2=$gwbyte[$i]+0;
            $gwByte=$b1&$b2;
            if($i != 0) {$gwAddr = $gwAddr . "." . $gwByte; }
            else        { $gwAddr=$gwByte ;}
         }
     if ( $gwAddr ne $NetAddr ) { $reconfigure=0; $update=0; $errmsg = "Invalid Gateway : $gw should match network $NetAddr/$mask"; }
  }
  else {  $reconfigure=0; $update = 0; $errmsg = "Gateway invalid: $gw"; }


  if (( $nfpeerip ne "") && ( $nfpeerip !~ /^($ipno\.){3}$ipno$/ )) {  $reconfigure=0; $update = 0; $errmsg = "Netflow peer invalid: $nfpeerip"; }



}

if ( $new_virt_lan == 1)
 {
	if ( $virt_lan_mask ne '' )
	{
  	if ($virt_lan_mask < 8 || $virt_lan_mask > 32) { $reconfigure=0; $update = 0; $new_virt_lan = 0; $errmsg = "MASK invalid: $mask";}
	}

	if ( $virt_lan_ip ne '' )
	{
	if ( $virt_lan_ip !~ /^($ipno\.){3}$ipno$/ ) { $reconfigure=0; $update = 0; $new_virt_lan = 0; $errmsg = "IP Invalid: $virt_lan_ip"; }
	}
 }

if ( $new_deployment == 1 && $deployment eq 'tunnel')
{
  foreach (values %peerips)
	{
	if ($_ !~ /^($ipno\.){3}$ipno$/ ) { $reconfigure=0; $update=0; $new_deployment=0; $errmsg = "MultiSite is missing a static Remote Peer IP"; }
	}

  if ($encapproto ne 'udp') { $reconfigure=0; $update=0; $new_deployment=0; $errmsg = "Tunnel mode requires UDP Encapsulation"; }
}

if ( $new_deployment == 1 && $deployment eq 'router' && $new_virt_lan == 0) { $reconfigure=0; $update=0; $new_deployment=0; $new_virt_lan=0; $errmsg = "Router mode requires a secondary addresse"; }
if ( $new_virt_lan == 1 && $deployment ne 'router') { $reconfigure=0; $update=0; $new_deployment=0; $new_virt_lan=0; $errmsg = "Secondary Addresses are only compatible with Router Mode"; }


if (($update == 1) || ($newencapproto == 1))
{
	$config{DSTORE} = $dstore;
	$config{SSHD} = $sshd;
	$config{MTU} = $mtu;
	$config{HOLD} = $hold;
	$config{NFEXPIRE} = $nfexpire;
	$config{NFEXPORT} = $nfexport;
	$config{NFPEERIP} = $nfpeerip;
	$config{NFPEERPORT} = $nfpeerport;
	$config{IP} = $ip;
	$config{GW} = $gw;
	$config{MASK} = $mask;
	$config{MODE} = $mode;
	$config{HOST} = $hostname;
	$config{SIM} = $sim;
	$config{COMPALGO} = $comp_lvl;
	$config{DD_LEVEL} = $dd_lvl;
	$config{RSP_LEVEL} = $rsp_lvl;
	$config{ENCAPPROTO} = $encapproto;
	$config{DNS_SERVER_1} = $dns1;
}

if ( $new_deployment == 1 )
{
$config{DEPLOYMENT_MODE} = $deployment;
}

if ( $new_virt_lan == 1 )
{
$config{VIRT_LAN0} = $virt_lan0;
}

print "Content-type: text/html;\n\n" . "<!DOCTYPE html>\n<html>\n<head>\n";

print <<END
  <link rel="stylesheet" href="/css/base.css" type="text/css"/>


<script langage="JavaScript">

window.onload = function(){
	var val = '$config{NFEXPORT}';
	if (val == "Disable")
	{ myform.nfpeerip.disabled = true; 
	  myform.nfpeerport.disabled = true; }

	var val = '$config{DEPLOYMENT_MODE}';
	if ((val == "bridge") || (val == "tunnel"))
	{ myform.virt_lan0.disabled = true; 
	  myform.virt_lan0.value = "";
	}
}

function enable_router() {
var val = myform.deployment.value;
    if(val == "router")
    {
	myform.virt_lan0.disabled=false;
	document.getElementById('lanipcheck').textContent = " Required by Router Mode.";
    }
    else
    {
	myform.virt_lan0.disabled=true;
	myform.virt_lan0.value="";
	document.getElementById('lanipcheck').textContent = ""; 
    }

    if ((val == "tunnel") && (myform.encapproto.value == "ipcomp"))
    {
	document.getElementById('encap').textContent = " Tunnel requires UDP"; 
    }
    else
    {
	document.getElementById('encap').textContent = " ";
    }
	
}

function encap_change(encapval) {
    if (encapval == "udp")
    {
	document.getElementById('encap').textContent = " "; 
    }
    if ((encapval == "ipcomp") && (myform.deployment.value == "tunnel"))
    {
	document.getElementById('encap').textContent = " Tunnel requires UDP"; 
    }
}

function enablefields() {
var val = myform.nfexport.value;
    if(val == "Enable")
    {
	myform.nfpeerip.disabled=false;
	myform.nfpeerport.disabled=false;
    }
    else
    {
	myform.nfpeerip.disabled=true;
	myform.nfpeerport.disabled=true;
    }
}
</script>

<script type="text/javascript">

function between (invar, min, max) {
    return invar >= min && invar <= max;
};

function beta(dd_lvl)
{
	if ((dd_lvl > 0) && (dd_lvl < 4)) { alert("Dedup levels 1-3 are new beta features. Levels 4 and 0 are recommended for production networks."); }
}

function myIPcheck(ip)
{
	var vars = ip.split("/");
	var mask = vars[1];
	if ( mask == undefined) { document.getElementById('wanipcheck').textContent = " Mask requried : IP/MASK"}
	else if ( mask < 8 || mask > 30 ) { document.getElementById('wanipcheck').textContent = " Mask between 8-30"}
	else { document.getElementById('wanipcheck').textContent = "" }
}

function check_router(ip)
{
	var vars = ip.split("/");
	var mask = vars[1];
	if ( mask == undefined) { document.getElementById('lanipcheck').textContent = " Mask required : IP/MASK"}
	else if ( mask < 8 || mask > 30 ) { document.getElementById('lanipcheck').textContent = " Mask between 8-30"}
	else { document.getElementById('lanipcheck').textContent = "" }
}


function doSubmit()
{
	var novalues = 0;
	var somevalues = 0;
	for(var i = 2; i < 7; i ++)
	{
		if(document.forms[0].elements[i].value == "")
		{
			novalues ++;
		}
		if(document.forms[0].elements[i].value != "")
		{
			somevalues ++;
		}
	}
	
	if ((novalues > 0) && (somevalues > 0))
	{
		alert("Please enter a full date and time");
	}
	if (novalues > 0) 
	{
		return true;
	}
	
	if(!between(document.forms[0].year.value,15,17))
	{
		alert("Year format invalid, please use: (15-17)!");
		return false;
	}
	
	if(!between(document.forms[0].month.value,1,12))
	{
		alert("Month format invalid, please use: (1-12)! ");
		return false;
	}
	if(!between(document.forms[0].day.value,1,31))
	{
		alert("Day format invalid, please use: (1-31)!");
		return false;
	}
	if(!between(document.forms[0].hour.value,0,24))
	{
		alert("Hour format invalid, please use: (0-23)!");
		return false;
	}
	if(!between(document.forms[0].minute.value,0,60))
	{
		alert("Minute format invalid, please use: (0-59)!");
		return false;
	}

	return true;
}

</script>


</head>
<body bgcolor="#FDFDFC" topMargin='5'>
<br><span class='header'>Settings</span>
<br >
<br >
	<form action="settings.pl" name="myform" method="post">
	<table class="cfg-table" style="width:840px;"><thead><tr><th colspan="3">System Settings</th></tr></thead>
	<tr><td width="50%" >Hostname</td><td width="18%" ></td><td width="35%" > <input name="host" type="text" size="16" maxlength="30" value="$config{HOST}" > </td></tr>
    <tr> <td >Date</td><td width="18%" ></td> <td ><input name="month" type="text" style="width:30px" title="Month value between (1-12)" id="month" value="" size="2" maxlength="2">
        <input name="day" type="text" style="width:30px" id="day" title="Day value between (1-31)" value="" size="2" maxlength="2">
        <input name="year" type="text" style="width:30px" id="year" value="" title="Year value between (15-17)" size="4" maxlength="4">
        &nbsp;(mm/dd/yy)</td>
    </tr>
    <tr>
      <td >Time</td><td width="18%" ></td>
      <td ><input name="hour" type="text" style="width:30px" id="hour" title="Hour value between (0-23)" value="" size="2" maxlength="2">
        <input name="minute" type="text" style="width:30px" id="minute" value="" title="Minute value between (0-59)" size="2" maxlength="2">
        <input name="second" type="text" style="width:30px" id="second" value="" title="Seconds value between (0-59)" size="2" maxlength="2">
        &nbsp;(hh/mm/ss)</td>
    </tr>
END
;
	print "<tr><td title='Remote Access via SSH'>SSH</td><td width='18%' ></td><td title='Remote Access via SSH'><select name='sshd' >\n";
	if ( $config{SSHD} eq 'disable' ) { print "<option value='disable' selected='selected'>Disable</option><option value='enable'>Enable</option></select>\n"; }
	if ( $config{SSHD} eq 'enable' ) { print "<option value='enable' selected='selected'>Enable</option><option value='disable'>Disable</option></select>\n"; }


	print "</td></tr><tr><td title='Datastore Partition'>Datastore</td><td width='18%' ></td><td title='Datastore Partition'><select name='dstore'  onchange='alert(\"Changing the partition will clear the datastore and reboot the system.\")' >\n";

# Disk partitions
foreach $partition (`/tce/etc/wanos/wanos-fdisk list`)
{
	($part, $partsize) = split(' ', $partition);
	if (( $config{DSTORE} eq $part ) || ( $drive[2] =~ /$part/ )) { print "<option value='$part' selected='selected'>$part  $partsize </option>\n"; }
	else { print "<option value='$part' >$part  $partsize </option>\n"; }
}

	print "</select>\n";


print <<END	
	<tr><td title='Optional DNS Server' >DNS Server</td><td></td><td title='Optional DNS Server'><input name="dns1" type="text" size="16" value="$config{DNS_SERVER_1}" ></td></tr> 
	</td></tr></table><br>
	<table class="cfg-table" style="width:840px"><tr><th colspan="3">Network Settings</th></tr>
	<tr><td width="50%" title='wan0 IP Address. Format: IP/MASK e.g. 192.168.1.200/24'>Wan IP Address / Mask</td><td width='18%' ></td><td width="35%" title='wan0 Interface IP Address'><input name="ip" type="text" size="16" value="$config{IP}/$config{MASK}" onblur="myIPcheck(this.value)"><span id="wanipcheck"></span></td></tr>
	<tr><td title='Gateway on wan0 interface'>Wan Gateway</td><td width='18%' ></td><td title='Gateway on wan0 interface'><input name="gw" type="text" size="16" value="$config{GW}"><span id="wanipgw"></span></td>

<!--
	<tr><td>Network Mask</td><td></td><td>
	<select name="mask">
	<option value="$config{MASK}" selected='selected'>$config{MASK}</option>
	<option value="30">30</option>
	<option value="29">29</option>
	<option value="28">28</option>
	<option value="27">27</option>
	<option value="26">26</option>
	<option value="25">25</option>
	<option value="24">24</option>
	<option value="23">23</option>
	<option value="22">22</option>
	<option value="21">21</option>
	<option value="20">20</option>
	<option value="19">19</option>
	<option value="18">18</option>
	<option value="17">17</option>
	<option value="16">16</option>
	</select></td></tr>
-->

	<!-- <tr><td title='MTU between Wanos appliances' >Path MTU</td><td title='MTU between Wanos appliances'><input name="mtu" type="text" size="16" value="$config{MTU}" ></td></tr> -->


	<tr><td title='Deployment Modes:&#013;
Bridge Mode is a transparent, inline, bump in the wire deployment using two interfaces. Requires little to no configuration.&#013;
Router mode uses only the wan0 interface, but uses two IP Address for inside and outside routing. Requires routing configuration on WAN and LAN.&#013;
Tunnel mode encapsulates optimized traffic in an UDP header and tunnels the traffic to the remote end. Requires MultiSite Peer IP configuration.
' width="50%">Deployment Mode</td><td width='18%' ></td><td title='Deployment Mode'><select name="deployment" id="deployment" onchange="enable_router()">
END
;

	 if ( $config{DEPLOYMENT_MODE} eq 'bridge' ) { print "<option value='bridge'>bridge</option><option value='router'>router</option><option value='tunnel'>tunnel</option>"; }
	 if ( $config{DEPLOYMENT_MODE} eq 'router' ) { print "<option value='router'>router</option><option value='bridge' >bridge</option><option value='tunnel'>tunnel</option>"; }
	 if ( $config{DEPLOYMENT_MODE} eq 'tunnel' ) { print "<option value='tunnel'>tunnel</option><option value='bridge' >bridge</option><option value='router'>router</option>"; }

print <<END

	<tr><td title='Router mode requires a secondary IP Address (inside). Format : IP/MASK e.g. 192.168.1.254/24&#013;When enabled internal traffic to be optimized should be routed to this gateway address.' >Secondary Address / Mask</td><td></td><td title=''><input name="virt_lan0" id="virt_lan0" type="text" size="16" value="$config{VIRT_LAN0}" onblur="check_router(this.value)"><span id="lanipcheck"></span></td></tr>
	</select>

	
	</table><br>
	
	<table class="cfg-table" style="width:840px"><tr><th colspan="3">Optimization Settings</th></tr>
<!-- 	<tr><td width="50%" title="High Sends & Receives, which provides the best reduction rates.&#013;Low receives only, which provides the best throughput speed.">Deduplication Level</td><td width='18%' ></td><td><select name="mode" title="High Sends & Receives, which provides the best reduction rates.&#013;Low Receives Only, which provides the best throughput speed.">  -->
END
;

#	if ( $config{MODE} eq 'Edge' ) { print "<option value='Edge' selected='selected'>Low</option><option value='Core' >High</option>\n"; }
#	if ( $config{MODE} eq 'Core' ) { print "<option value='Core' selected='selected'>High</option><option value='Edge' >Low</option>\n"; }

	print <<END
	<tr><td width="50%" title='Level 3 for best results. 0 to Disable.' >Compression Level</td><td width='18%'></td><td>
	<select name="comp_lvl" title='Level 3 for best results. 0 to Disable.'>
	<option value="$config{COMPALGO}" selected='selected'>$config{COMPALGO}</option>
	<option value="0">0</option>
	<option value="1">1</option>
	<option value="2">2</option>
	<option value="3">3</option>
	<option value="4">4</option>
	</select></td></tr>
	<tr><td title='4 : Best Results.&#013;0 : Receive Only.' >Deduplication Level</td><td></td><td>
	<select onchange='return beta(this.value)' name="dd_lvl" title='4 : Best Results.&#013;0 : Receive Only.'>
	<option value="$config{DD_LEVEL}" selected='selected'>$config{DD_LEVEL}</option>
	<option value="0">0</option>
	<option value="1">1 *</option>
	<option value="2">2 *</option>
	<option value="3">3 *</option>
	<option value="4">4</option>
	</select></td></tr>
	<tr><td title='Level 1 - Most Conservative loss detection and recovery.&#013;Level 4 - Most Aggressive loss detection and recovery.' >Packet Loss Recovery</td><td></td><td>
	<select name="rsp_lvl" title='Level 1 - Most Conservative loss detection and recovery.&#013;Level 4 - Most Aggressive loss detection and recovery.'>
	<option value="$config{RSP_LEVEL}" selected='selected'>$config{RSP_LEVEL}</option>
	<option value="1">1</option>
	<option value="2">2</option>
	<option value="3">3</option>
	<option value="4">4</option>
	</select></td></tr>
	<tr><td title="Encapsulation for optimized traffic needs to match on all sites">Encapsulation</td><td></td><td>
	<select name="encapproto" id="encapproto" title="Encapsulation for optimized traffic needs to match on all sites" onchange="encap_change(this.value)">
END
;

	foreach $encap ('ipcomp', 'udp')
	{
	    print "<option value='" . $encap . "' ";
	    if ( $encap eq $config{ENCAPPROTO} ) { print "selected='selected'"; }
	    print ">" . $encap . "</option>\n";
	}

	print <<END
	</select><span id='encap'></span></td></tr>
	<tr><td title='Peer holdtime timeout seconds' >Peer Timeout</td><td></td><td><input name="hold" type="text" size="16" value="$config{HOLD}"></td></tr>
END
;
	print "</td></tr><tr><td title='The Global WAN Outbound Tx Shaper. 0 to Disable. Rate in kbps'>Global Wan Tx Rate</td><td></td><td title='The Global WAN Outbound Tx Shaper. 0 to Disable. Rate in kbps'>\n";
	print "<input name='sim' type='text' size='16' value='" . $config{SIM} . "'\n"; 

	print <<END
	</td></tr></table><br />
	<table class="cfg-table" style="width:840px"><tr><th colspan="3">Netflow Settings</td></tr>
	<tr><td title='Enable external netflow collector' width="50%">Netflow Exports</td><td width='18%' ></td><td title='Enable external netflow collector'><select name="nfexport" id="nfexport" onchange="enablefields()">
END
;

	 if ( $config{NFEXPORT} eq 'Disable' ) { print "<option value='Disable'>Disable</option><option value='Enable'>Enable</option>"; }
	 if ( $config{NFEXPORT} eq 'Enable' ) { print "<option value='Enable'>Enable</option><option value='Disable' >Disable</option>"; }

print <<END
</td></tr>
	<tr><td title='Optional external netflow collector' >Netflow Collector IP</td><td></td><td title='Optional external netflow collector'><input name="nfpeerip" id="nfpeerip" type="text" size="16" value="$config{NFPEERIP}"></td></tr>
	<tr><td title='External netflow collector port' >Netflow Collector Port</td><td></td><td title='External netflow collector port'><input name="nfpeerport" type="text" size="16" value="$config{NFPEERPORT}" ></td></tr>
<!--	<tr><td title='Netflow local history in hours' width="50%">Netflow Local History</td><td></td><td title='Netflow local history in hours'><input name="nfexpire" type="text" size="16" value="$config{NFEXPIRE}" ></td></tr> -->
	</td></tr></table><br>
END
;

  if (($update == 0) && ($newencapproto == 0))
  {
	print "<input type='submit' value='Submit' size='3' onclick='return doSubmit();' style='font-size: 8pt; position:relative; left:20;'><br />\n";
  }

  if ($errmsg ne '') 
  {
	print "<br /><div style='position:relative; left:20;'><b>Unsuccessful :</b><br />\n";
	print "<br /><div style='position:relative; left:20;'><b>$errmsg</b><br />\n";
	print "</form><br></body></html>\n";
	exit;
  }

  if ($update == 1)
  {
	print "<br /><button onclick=\"top.location.href= 'https://$config{IP}:443/';\" class='float-left submit-button' size='3' style='font-size: 8pt;'>Home</button><br /><br />\n";
	print "<br /><b>New settings applied.<br />\n";
  }

  if ($new_deployment == 1)
  {
	print "<br /><b>New deployment applied. <br />\n";
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -deployment $deployment ");
  }

  if ($new_virt_lan == 1)
  {
	print "<br /><b>New VIRT_LAN0 address applied. $virt_lan0<br />\n";
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -virtlan $virt_lan0 ");
  }

  if ($reboot == 1 && $update == 1)
  {
	print "<br /><b>Wanos will reboot to apply new Datastore settings.<br />\n";
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -dstore $dstore ");
  }


  if ($sshupdate == 1 )
  {
	print "<br /><b>Applying SSH settings. Established SSH sessions may be terminated.<br />\n";
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -sshd $sshd ");
  }

  if ($time == 1)
  {
	 print "<br /><b>Setting new system time:<br />\n";
	 open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -time $time_day $time_month $time_year $time_hour $time_minute ");
	 print "<br />\n";
  }

if ($newencapproto == 1)
{
	print "<br /><b>New encapsulation applied.<br />\n";
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -encapproto $encapproto ");
}

if ($dnsupdate == 1)
{
	print "<br /><b>Applying new DNS settings.<br />\n";
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -dnsupdate $dns1 ");
}


if ($reconfigure == 1 ) 
  {
	print "<br /><b>Restarting Wanos Service<br />\n";
	print "</form><br></body></html>\n";
  }

if ($update == 1)
{
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -sys $mode $sim ");
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -comp_lvl $comp_lvl ");
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -dd_lvl $dd_lvl ");
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -rsp_lvl $rsp_lvl ");
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -host $hostname ");
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -nfpeerip $nfpeerip ");
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -net $ip $mask $NetAddr $gw ");
	open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -settings $mtu $hold $nfexpire $nfpeerport $nfexport ");
	
}

if ($reboot == 1 && $update == 1) 
{
   open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -reboot &");
   exit 0;
}

if ($reconfigure == 1 ) 
{
   open(CMD, "|sudo -u tc /tce/etc/wanos/makewanoscfg.sh -reconfigure &");
}

