#!/usr/bin/perl
#
# Copyright (c) 2010-2015 Wanos Networks Pty(Ltd). All rights reserved.
#
# Modification of this software is not permitted under the licensing
# agreement. Please read the license as well as terms and conditions at
# http://wanos.co/license or email info@wanos.co for more information.
#

use CGI;
use warnings;
use Cwd qw(abs_path);

print "Content-type: text/html;\n\n";

my $cgi = CGI->new;
my $name = $cgi->param("trend");
my $desc = $cgi->param("desc"); 

my @graphs;
push (@graphs, "cpu,CPU Load", "diskio,Disk Input/Output", "memory,RAM Utilization");


open(CONFIG, "<" , "/tce/etc/wanos/wanos.conf") || die("Couldn't open the file. Error: $!\n");
    while (<CONFIG>)
    {
    chomp;
    next if /^\s*\#/;
    next unless /=/;
    my ($key, $variable) = split(/\s*=\s*/,$_,2);
    $variable =~ s/(\$(\w+))/$config{$2}/g;
        $config{$key} = $variable;
    }
close CONFIG;

### Drive the DS is mounted on
my $link = '/wanos';
my $path = abs_path($link);
my @drive  = split '/', $path;
my @drive_used = split ' ', `df -h | grep ^/dev/$drive[2]`;
chop($drive_used[4]);

my @totals = split(/ /, `tail -1 /tce/www/stats/reduction`);
$total=sprintf '%.2f', (($totals[0]-$totals[1])/1024000000);

my @uptime = split(/ /, `uptime`);
$up="$uptime[3] $uptime[4] $uptime[5]";
chop($up);

open(ROW, "<" , "/tce/etc/wanos/peersites") || die("Couldn't open the file. Error: $!\n");
while (<ROW>)
{
        chomp;
        next if /^\s*\#/;
        next unless /=/;
        my ($key, $commastring) = split(/\s*=\s*/,$_,2);
        $commastring =~ s/(\$(\w+))/$rows{$2}/g;
        $rows{$key} = $commastring;
        my @values = split(',',$commastring);
        $sites{$values[1]} = $values[0];
}
close ROW;

=HEAD1
open(INFO, "<" , "/tce/etc/wanos/license.info") || die("Couldn't open the file. Error: $!\n");
    while (<INFO>)
    {
    chomp;
    next if /^\s*\#/;
    next unless /=/;
    my ($key, $variable) = split(/\s*=\s*/,$_,2);
    $variable =~ s/(\$(\w+))/$info{$2}/g;
        $info{$key} = $variable;
    }
close INFO;
$license = $info{TYPE};
if ($info{STATUS} eq "Unlicensed" ) { $license = "Express 1/10 Mbps";}
elsif ($license eq "1147100002" ) { $license = "Plus";}
elsif ($license eq "1147100003" ) { $license = "Express 1/10 Mbps";}
elsif ($license eq "1147100004" ) { $license = "Express 2/20 Mbps";}
elsif ($license eq "1147100005" ) { $license = "Express 4/40 Mbps";}
elsif ($license eq "1147100006" ) { $license = "Express 6/60 Mbps";}
elsif ($license eq "1147100007" ) { $license = "Express 10/100 Mbps";}
elsif ($license eq "1147100008" ) { $license = "Express 20/200 Mbps";}
elsif ($license eq "1147100009" ) { $license = "Express 50/200 Mbps";}
elsif ($license eq "1147100010" ) { $license = "Express 100/200 Mbps";}
elsif ($license eq "1147100011" ) { $license = "Express 200/200 Mbps";}
elsif ($license eq "1147100012" ) { $license = "Express 1 Gbps";}
elsif ($license eq "1147100020" ) { $license = "Plus 2/20 Mbps";}
elsif ($license eq "1147100021" ) { $license = "Plus 4/40 Mbps";}
elsif ($license eq "1147100022" ) { $license = "Plus 6/60 Mbps";}
elsif ($license eq "1147100023" ) { $license = "Plus 10/100 Mbps";}
elsif ($license eq "1147100024" ) { $license = "Plus 20/200 Mbps";}
elsif ($license eq "1147100025" ) { $license = "Plus 50/200 Mbps";}
elsif ($license eq "1147100026" ) { $license = "Plus 100/200 Mbps";}
elsif ($license eq "1147100027" ) { $license = "Plus 200/200 Mbps";}
elsif ($license eq "1147100028" ) { $license = "Plus 1 Gbps";}
else { $license = "None"; }
=cut

@info=`/tce/etc/wanos/makewanoscfg.sh -aqm_name`;
foreach (@info)
{
next unless /NAME=/;
$prod_name = (split(/=/,$_,2))[1];
}

# get load value
$load =`cat /proc/loadavg`;
@array = split ' ', $load;
$load=$array[0]*20;

# get cpu value
$cpu=`top -n1 | grep ^CPU:`;
@array = split ' ', $cpu;
$cpu=$array[1];
$cpu=~ s/%//;
$cpu_threads=`awk '/^processor/ {count++} END {print count}' /proc/cpuinfo`;

# get mem %
$mem=`cat /tce/www/stats/memprec`;
$totalmem=sprintf '%.1f', ((split " ", `head -1 /proc/meminfo`)[1]/1024000);

# datastore stats
@array=sort { $a <=> $b } keys(%sites); 
$cfgsites = @array;
$cfgsites = ($cfgsites * ($config{DS_SIZE}/1024));
$disk =`du -s /wanos/ds0/ | awk {'print $1'}`;
$disk = sprintf '%.2f', $disk/1024/1024;
$disk = ($disk/$cfgsites)*100;
$disk = sprintf '%.0f', $disk;


print <<END
<!DOCTYPE html>
<html>
<head>
  <TITLE>System Overview</TITLE>
  <META HTTP-EQUIV="Refresh" CONTENT="300">
  <META HTTP-EQUIV="Cache-Control" content="no-cache">
  <META HTTP-EQUIV="Pragma" CONTENT="no-cache">
  <style>
    body { font-family: Verdana,Tahoma,Arial,Helvetica; font-size:8pt; font-weight: 500; color: 5F5F5F; margin-left:30px;}
    .header { font-size: 8pt; font-weight: 900; color: 777777 }
  </style>
<link rel="stylesheet" href="/css/base.css" type="text/css"/>
<style>
	#box {
	width: 13px;
	height: 13px;
	}
      
      #g1, #g2, #g3, #g4, #g5 {
        width:120px; height:100px;
        display: inline-block;
        margin: 1em;
      }
          
      p {
        display: block;
        width: 450px;
        margin: 2em auto;
        text-align: left;
      }

</style>
 
    <script src="/js/raphael.2.1.0.min.js"></script>
    <script src="/js/justgage.1.0.1.min.js"></script>
<script>
	// Indicators
	var g1, g2, g3, g4, g5;
      
	window.onload = function(){
	var g1 = new JustGage({
	id: "g1", 
	value: $load, 
        min: 0,
        max: 100,
        title: "Load",
        label: "",    
        gaugeWidthScale: 0.2          
	});

	var g2 = new JustGage({
	id: "g2",
	value: $cpu,
	min: 0,
	max: 100,
	title: "CPU",
	label: "",
	gaugeWidthScale: 0.2
	});

	var g3 = new JustGage({
	id: "g3",
	value: $mem,
	min: 0,
	max: 100,
	title: "Memory",
	label: "",
	gaugeWidthScale: 0.2
	});
      
	var g4 = new JustGage({
	id: "g4", 
	value: $disk, 
	min: 0,
	max: 100,
	title: "Datastore",
	label: "",    
	gaugeWidthScale: 0.2,
	levelColors: [
	"#006eff",
	"#00fff6",
	"#a9d70b"
	] 
	});

	var g5 = new JustGage({
	id: "g5",
	value: $drive_used[4],
	min: 0,
	max: 100,
	title: "Disk",
	label: "",
	gaugeWidthScale: 0.2
	});
      
}
</script>


</head>
<body bgcolor="#FDFDFC" topMargin='5'>

<br><span class='header'>System Overview</span>
<br><br>
<br><div style='margin-left:0px'>
<div style="width:840px;" >
                <table class="striped sortable">
		<thead>
                    <tr>
                        <th colspan="2">
                            System Information
                        </th>
                    </tr>
		</thead>
                    <tr>
                        <td width='50%'>
                            Hostname
                        </td>
                        <td width='50%'>
                           $config{HOST}
                        </td>
                    </tr>
                    <tr>
                        <td width='50%'>
                            Software Version
                        </td>
                        <td width='50%'>
                            $config{VERSION} $prod_name
                        </td>
                    </tr>
					<tr>
                        <td width='50%'>
                            CPU Threads
                        </td>
                        <td width='50%'>
                            $cpu_threads
                        </td>
                    </tr>
					<tr>
                        <td width='50%'>
                            Datastore Disk
                        </td>
                        <td width='50%'>
                            $drive[2]
                        </td>
                    </tr>
                    <tr>
                        <td width='50%'>
                            System Memory
                        </td>
                        <td width='50%'>
                            $totalmem GB
                        </td>
                    </tr>
                    <tr>
                        <td width='50%'>
                            Total GB Saved
                        </td>
                        <td width='50%'>
                            $total GB
                        </td>
                    </tr>
                    <tr>
                        <td width='50%'>
                            Uptime
                        </td>
                        <td width='50%'>
                            $up
                        </td>
                    </tr>
                </table>
            </div>
</div><br>
<table class='graph-table' style="width:840px">
<tr><th>Indicators</th></tr>
<tr><td>
<center>
<div style="width: 810px; float:left;">
    <div id="g1"></div>
    <div id="g2"></div>
    <div id="g3"></div>
    <div id="g5"></div>
    <div id="g4"></div>
</div>
</center>
</td></tr>
</table>
<br>

END
;

if ($name eq '')
{
	foreach $graph (@graphs)
	{
        ($graphname, $desc) = split(',', $graph);
        print "<table class='graph-table' style='width:840px'><tr><th>$desc</th></tr><tr><td><div style='margin-left:90px'><a href='?trend=$graphname&desc=$desc'><img src='/stats/$graphname-Day.png' border='0'><br></a></div></td></tr></table><br><br>";
	}
}
else
{
        foreach $period ("Hour", "Day", "Week", "Month", "Year")
        {
        print "<table class='graph-table' style='width:840px'><tr><th>$desc : $period</th></tr><tr><td><div style='margin-left:90px'><img src='/stats/$name-$period.png' border='0'><br></div></td></tr></table><br><br>\n";
        }
}

print <<END
<br><br>
</body>
</html>
END
;
